#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <cstrike>
#include <fun>
#include <nvault>

#define PLUGIN "American Football Mod"
#define VERSION "4.0"
#define AUTHOR "WhooKid"

new Football,CTtd_loc[4],Ttd_loc[4],Scrimage_loc,FirstD_loc,T_QB,CT_QB,QB_lock[4],Burst[33],BrsCnt[33],ScoreClock[4],NoRushing;
new Stats[33][13],GameActive,Tourney,Kicking,FGallow,FieldGoal,Float:FGstat[2],PAT,Fumblestat[2],StatSnap,TeamWithBall,CurDown;
new Float:lastmove[33],spr[2],fdtime,tscore,ctscore,dwnum,dwnum2,g_msgsync,g_msghelp,g_msgsboard;

public plugin_init()
{
	register_plugin(PLUGIN,VERSION,AUTHOR);
	
	if (load_football())
	{
		register_event("ResetHUD","ev_resethud","b");
		register_event("CurWeapon","ev_models","be");
		register_event("AmmoPickup","ev_models","b","1=12");
		register_event("Damage","on_damage","b","2!0","3=0","4!0");

		register_cvar("fm_version",VERSION,FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_downs","3",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_helpmsg","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_afktimer","40",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_maxscore","49",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_maxspeed","260",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_kickoffs","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_kickminlen","30",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_fieldgoals","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_playclock","5",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_rushclock","0",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_evenusers","4",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_fumblerate","50",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_freezeuser","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_allowpitch","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_allowburst","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_burstspeed","350",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_allowpushoff","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		register_cvar("fm_allowstatreset","1",FCVAR_SERVER|FCVAR_UNLOGGED);
		
		register_clcmd("say","handle_say");
		register_clcmd("say_team", "handle_say");
		register_clcmd("say /qb","act_qb",_,"<Make you the QB>");
		register_clcmd("fm_qb","act_qb",_,"<Make you the QB>");
		register_clcmd("say_team /qb","act_qb",_,"<Make you the QB>");
		register_clcmd("say /start","start_game",_,"<Starts a new Football game>");
		register_clcmd("say /switch","act_switch",_,"<Switches a players team>");
		register_clcmd("say /help","display_info",_,"<Displays help MOTD>");
		register_clcmd("say_team /switch","act_switch",_,"<Switches a players team>");
		register_clcmd("radio1","act_fieldgoal",_,"<Initiate a Field Goal>"); //(unfinished)

		register_concmd("amx_setqb","set_qb",ADMIN_KICK,"<name or #userid>");
		register_concmd("amx_setdown","set_down",ADMIN_KICK,"<new down #>");
		register_concmd("amx_setscore","set_score",ADMIN_KICK,"<T|CT|1|2> <new score #>");
		register_concmd("amx_makeburst","make_burst",ADMIN_KICK,"<make a player have a speed burst>");
		register_concmd("amx_makekick","set_kick",ADMIN_KICK,"<Forces a team to Kickoff>");
		register_concmd("amx_scrim","set_scrim",ADMIN_KICK,"<Toggles Tourney/Scrim Mode>");
		register_concmd("amx_tourney","set_scrim",ADMIN_KICK,"<Toggles Tourney/Scrim Mode>");
		register_concmd("amx_end","display_winner",ADMIN_KICK,"<Ends the current game>");
		register_concmd("amx_shake","teams_shake",ADMIN_KICK,"<Randomizes the players within Ts and CTs>");

		engfunc(EngFunc_PrecacheModel,"models/p_football.mdl");
		engfunc(EngFunc_PrecacheModel,"models/v_football.mdl");
		engfunc(EngFunc_PrecacheModel,"models/w_football.mdl");
		engfunc(EngFunc_PrecacheModel,"models/p_hands.mdl");
		engfunc(EngFunc_PrecacheModel,"models/v_hands.mdl");
		engfunc(EngFunc_PrecacheSound,"football/int.wav");
		engfunc(EngFunc_PrecacheSound,"football/hut.wav");
		engfunc(EngFunc_PrecacheSound,"football/cheer1.wav");
		engfunc(EngFunc_PrecacheSound,"football/cheer2.wav");
		engfunc(EngFunc_PrecacheSound,"football/cheer3.wav");
		engfunc(EngFunc_PrecacheSound,"football/cheer4.wav");
		engfunc(EngFunc_PrecacheSound,"football/cheer5.wav");
		engfunc(EngFunc_PrecacheSound,"football/cheer6.wav");
		engfunc(EngFunc_PrecacheSound,"football/whistle.wav");

		register_forward(FM_Think,"pfn_think");
		register_forward(FM_CmdStart,"fw_start",1);
		register_forward(FM_SetModel,"fw_setmodel",0);
		register_forward(FM_GetGameDescription,"fw_gamedesc");

		register_message(77,"msg_textmsg");// TextMsg
		register_message(100,"msg_sendaudio");// SendAudio

		set_msg_block(122,BLOCK_SET);// ClCorpse block

		server_print("*** %s v%s by %s Enabled ***",PLUGIN,VERSION,AUTHOR);

		start_game();
	}
}

// precache sprites/hud messages
public plugin_precache()
{
	spr[0] = precache_model("sprites/laserbeam.spr");
	spr[1] = precache_model("sprites/shockwave.spr");
	g_msgsync = CreateHudSyncObj();
	g_msghelp = CreateHudSyncObj();
	g_msgsboard = CreateHudSyncObj();
}

// checks to see if current map has the right entitys to play fb
public load_football()
{
	// go through all the ents
	new targetname[32], Float:origin[3], Float:angles[3], bool:cachedspr, Float:sideline;
	for (new a=0; a<=engfunc(EngFunc_NumberOfEntities)+4; a++)
		if (pev_valid(a))
		{
			pev(a,pev_targetname,targetname,31);
			if (equali(targetname,"goal1") || equali(targetname,"goal2"))
				FGallow = 1; // make players able to kick field goals
			if (equali(targetname,"terrorist_td") || equali(targetname,"counter_td"))
			{
				pev(a,pev_origin,origin);
				for (new b=0;b<3;b++)
					if (equali(targetname,"terrorist_td"))
						Ttd_loc[b] = floatround(origin[b]);
					else
						CTtd_loc[b] = floatround(origin[b]);
			}
			else if (equali(targetname,"terrorist_score") || equali(targetname,"counter_score"))
			{
				pev(a,pev_origin,origin);
				pev(a,pev_angles,angles);
				if (!cachedspr) { engfunc(EngFunc_PrecacheModel,"sprites/clock_digits.spr"); cachedspr = true; }
				make_scoreclock(targetname,origin,angles,float(pev(a,pev_scale)));
			}
			else if (equali(targetname,"sideline"))
			{
				pev(a,pev_origin,origin);
				sideline = origin[1];
			}
			else continue; // ent isnt a fb ent so continue so it doesnt get erased
			// erase fb ent now since we are done with it
			engfunc(EngFunc_RemoveEntity,a);
		}
	// set the final sideline difference
	if (sideline)
		Ttd_loc[3] = CTtd_loc[3] = floatround(sideline-CTtd_loc[1]);
	// check to see if the td locations are corrent
	if (Ttd_loc[0] != CTtd_loc[0])
		Football = 1;
	else
		log_amx("Playing non football map.");
	return Football;
}

// grenade is thrown
public grenade_throw(index,greindex,wId) 
{
	if (!Football)
		return;

	// set some variables
	set_pev(greindex,pev_iuser1,0);
	set_pev(greindex,pev_friction,0.6);
	set_pev(greindex,pev_euser1,index);
	engfunc(EngFunc_SetSize,greindex,Float:{-6.6,-6.6,-6.6},Float:{6.6,6.6,6.6});

	// make a trail for the ball
	new clr[6];
	for (new a=0;a<2;a++)
	{
		if(a)		clr = { 0, 255, 0, 15, 10, 200 }
		else		clr = { 255, 255, 0, 10, 5 , 250 }

		message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
		write_byte(TE_BEAMFOLLOW);	// TE_BEAMFOLLOW
		write_short(greindex);		// ball
		write_short(spr[0]);		// laserbeam
		write_byte(clr[3]);		// life
		write_byte(clr[4]);		// width
		write_byte(clr[0]);		// red
		write_byte(clr[1]);		// green
		write_byte(clr[2]);		// blue
		write_byte(clr[5]);		// brightness
		message_end();
	}

	// make it glow and player not glow
	fm_set_rendering(greindex,kRenderFxGlowShell,0,255,0);
	fm_set_rendering(index);

	// stop the ball from rolling unlimitedly
	set_task(2.0,"slow_ball",greindex+6000);
	set_task(2.5,"act_shockwave",greindex+7000);

	// if no game is active then leave the nade alone.
	if (!GameActive || wId==10000 || get_user_team(index)==3)
		return;

	// perform ingame checks
	switch (StatSnap)
	{
		case 0: {
			act_snap(index);
			// set timer incase of an error somewhere
			remove_task(306);
			set_task(15.0,"play_over2",306);
		}
		case 1: {
			new origin[3];
			get_user_origin(index,origin);
			if (((origin[0]<Scrimage_loc && get_user_team(index)==1) || (origin[0]>Scrimage_loc && get_user_team(index)==2)) || FirstD_loc==10000)//if FirstD_loc=10000 then the ball has been intercepted
			{
				set_pev(greindex,pev_iuser1,1); // dead ball
				fm_set_rendering(greindex); // get rid of glow
				play_over(1,index);
			}
			else if (!Kicking)
			{
				display_comment(2,index);
				// display third white help message
				display_help(3);
			}
			// set timer incase of an error somewhere
			remove_task(306);
			set_task(15.0,"play_over2",306);
		}
		case 2: {
			set_pev(greindex,pev_iuser1,1); // dead ball
			fm_set_rendering(greindex); // get rid of glow
		}
	}
}

// anything touches anyone
public pfn_touch(ent,id)
{
	// two players collide and push each other
	if (is_user_alive(ent) && is_user_alive(id))
	{
		if (get_cvar_num("fm_allowpushoff") && StatSnap && (Tourney || !is_user_admin(id)))
		{
			new Float:momntm[2][3];
			pev(ent,pev_origin,momntm[0]);
			pev(id,pev_origin,momntm[1]);
			for (new a=0;a<2;a++)
			{
				momntm[1][a] -= momntm[0][a];
				momntm[1][a] *= 7;
			}
			momntm[1][2] = -40.0;
			set_pev(id,pev_velocity,momntm[1]);
		}
		return;
	}

	// check to see if ball is touching fieldgoal ent.
	new targetname[32],classname[32];
	pev(ent,pev_targetname,targetname,31);
	if (equali(targetname,"goal1") || equali(targetname,"goal2"))
	{
		pev(id,pev_classname,classname,31);
		if (equali(classname,"grenade") && !pev(id,pev_iuser1) && pev(id,pev_iuser2) && ((get_user_team(pev(id,pev_euser1))==1 && equali(targetname,"goal2")) || (get_user_team(pev(id,pev_euser1))==2 && equali(targetname,"goal1"))))
		{
			// kill the ball
			set_pev(id,pev_iuser1,1);
			// get rid of glow
			fm_set_rendering(id); 
			// end play with a good field goal
			play_over(3,id);
			return;
		}
	}

	// make sure we are dealing with a football
	pev(ent,pev_classname,classname,31);
	if (!equali(classname,"grenade") || !Football)
		return;

	// if no game is active then give them a new nade			
	if (!GameActive && is_user_alive(id))
	{
		if (!user_has_ball(id))
		{
			give_item(id,"weapon_hegrenade");
			engfunc(EngFunc_RemoveEntity,ent);
		}
		return;
	}

	// get balls origin
	new Float:origin[3];
	pev(ent,pev_origin,origin);

	// clear owner
	if (pev(ent,pev_owner))
		set_pev(ent,pev_owner,0);

	// ball hits anything other than a player
	if (!pev(ent,pev_iuser1) && !is_user_alive(id))
	{
		// make ball jump/slow
		new Float:velo[3];
		pev(ent,pev_velocity,velo);
		if (velo[0]>0) velo[0]-=random_num(70,140); else velo[0]+=random_num(70,140);
		if (velo[1]>0) velo[1]-=random_num(70,140); else velo[1]+=random_num(70,140);
		set_pev(ent,pev_velocity,velo);
		// kill the ball
		set_pev(ent,pev_iuser1,1);
		// get rid of glow
		fm_set_rendering(ent); 
		// game related actions
		if (GameActive && StatSnap!=2 && !Kicking)
		{	
			// check to see if ball was kicked for a fg
			if (pev(ent,pev_iuser2))
			{
				display_comment(38,pev(ent,pev_iuser2));// say kick is no good
				play_over(4,0);// end play and reset
			}
			// check to see if the ball is past the scrimage line
			else if (((origin[0]>Scrimage_loc && TeamWithBall==1) || (origin[0]<Scrimage_loc && TeamWithBall==2)) && FirstD_loc!=10000)//if FirstD_loc=10000 then the ball has been intercepted
			{
				fm_set_rendering(ent,kRenderFxGlowShell,0,255,0);
				display_comment(24,0);
			}
			// if it past then its a dead ball and missed pass
			else
			{
				if (!FieldGoal)
					display_comment(4,nearest_teammate(ent));
				play_over(2,0);
			}
		}
		else if (GameActive && Kicking && StatSnap!=2)
		{
			// check to see if the kick is too short, otherwise let it go
			if ((Kicking==1 && ((origin[0]-Scrimage_loc)/30.0)<get_cvar_num("fm_kickminlen")) || (Kicking==2 && ((Scrimage_loc-origin[0])/30.0)<get_cvar_num("fm_kickminlen")))
			{
				display_comment(20,0);
				play_over(2,0);
			}
		}
	}
	// ball hits a player and he catches it
	else if (StatSnap != 2 && is_user_alive(id))//if StatSnap=2 then play is dead
	{
		//leave the ball if user is a spectator
		if (get_user_team(id) == 3)
			return;
		//check for interception
		else if (get_user_team(id) != TeamWithBall && !Kicking) 
		{
			FirstD_loc = 10000;
			client_cmd(0, "spk ^"football/int.wav^" ");
			display_comment(pev(ent,pev_iuser2) ? 39 : 23,id);
			act_lflash(id);
			if (!pev(ent,pev_iuser1) && !pev(ent,pev_iuser2))// check if its a int
			{
				display_comment(6,id);
				//add a int for player and qb to stats
				Stats[pev(ent,pev_euser1)][6]++;
				Stats[id][8]++;
				//add a thrownto for the nearest wr
				new wr = nearest_teammate(ent);
				if (wr)
					Stats[wr][2]++;
			}
		}
		// check for forward pass
		else if (((origin[0]<Scrimage_loc && get_user_team(id)==1) || (origin[0]>Scrimage_loc && get_user_team(id)==2)) && FirstD_loc != 10000 && !pev(ent,pev_iuser1))// if the pass isnt an interception display catch
		{
			display_comment(10,id);
			//add a completion for qb to stats
			Stats[pev(ent,pev_euser1)][4]++;
		}
		// pickup ball randomly
		else 
			display_comment(23,id);
		// make sure the play is far enough on a kickoff
		if (!pev(ent,pev_iuser1) && get_user_team(id)!=Kicking && ((Kicking==1 && ((origin[0]-Scrimage_loc)/30.0)<get_cvar_num("fm_kickminlen")) || (Kicking==2 && ((Scrimage_loc-origin[0])/30.0)<get_cvar_num("fm_kickminlen"))))
		{
			display_comment(20,0);
			play_over(2,0);
			return;
		}
		// clear kickoffs
		if (Kicking)
		{
			Kicking = 0;
			//clear scrim line for touchback
			Scrimage_loc = (get_user_team(id)==1) ? Ttd_loc[0]+1 : CTtd_loc[0]-1;
		}

		engfunc(EngFunc_RemoveEntity,ent);
		TeamWithBall = get_user_team(id);
		give_item(id,"weapon_hegrenade");
		// give a frag for a catch
		set_pev(id,pev_frags,float(get_user_frags(id)+1));
		// kill the error timer
		remove_task(306);
		fm_set_rendering(id,kRenderFxGlowShell,0,0,250,kRenderTransAlpha,255);
		setup_tackle();
	}
}

// setups up both teams and the ball carrier is active
public setup_tackle()
{
	new players[32],num;
	get_players(players,num,"a");
	for (new i=0;i<num;i++) 
	{
		if (get_user_team(players[i])==3)
			continue;
		if (get_user_team(players[i])==TeamWithBall)	
		{
			if (user_has_ball(players[i]))
			{
				set_user_godmode(players[i]);
				if (task_exists(players[i]+905))
					continue;
				// slow him down a lil extra if hes the QB just cause
				if (Kicking || Scrimage_loc==Ttd_loc[0]+1 || Scrimage_loc==CTtd_loc[0]-1)
					set_user_maxspeed(players[i],float(get_cvar_num("fm_maxspeed")));
				else
					set_user_maxspeed(players[i],float((players[i]==CT_QB || players[i]==T_QB) ? get_cvar_num("fm_maxspeed")-60 : get_cvar_num("fm_maxspeed")-30));
			}
			else
			{
				strip_user_weapons(players[i]);
				set_user_godmode(players[i],1);
				if (!task_exists(players[i]+905))
					set_user_maxspeed(players[i],float(get_cvar_num("fm_maxspeed")));
			}
		}
		else
		{
			if (user_has_ball(players[i]))
				strip_user_weapons(players[i]);
			give_item(players[i],"weapon_knife");
			set_user_godmode(players[i],1);
			if (!task_exists(players[i]+905))
				set_user_maxspeed(players[i],float(get_cvar_num("fm_maxspeed")));
		}
	}
}

// someone gets hit!!
public on_damage(id)
{
	if (id)
	{
		new origin[3],null,attacker = get_user_attacker(id);
		if (is_user_alive(id) && is_user_alive(attacker))
		{
			if (user_has_ball(id) && get_user_weapon(attacker,null,null)==CSW_KNIFE && get_user_team(id)!=get_user_team(attacker) && StatSnap!=2)
			{
				// check to see if we are gonna fumble
				if (!Tourney && !Fumblestat[0] && random_num(0,get_cvar_num("fm_fumblerate"))==1)
				{
					Fumblestat[1]++;
					new ball = make_ball(id),Float:velocity[3];
					velocity[0] = random_num(0,1) ? random_float(-60.0,-140.0) : random_float(60.0,140.0);
					velocity[1] = random_num(0,1) ? random_float(-60.0,-140.0) : random_float(60.0,140.0);
					velocity[2] = 300.0;
					set_pev(ball,pev_velocity,velocity);
					display_comment(27,attacker);
				}
				else
				{
					// say the tackle message
					display_comment(3,attacker);
					// end the current play/down
					play_over(1,id);
					// freeze player
					get_user_origin(id,origin);
					origin[2] = CTtd_loc[2]-10;
					set_user_origin(id,origin);
				}
				// give godmode so he doesn't die
				set_user_godmode(id,1);
				// make player not glow
				fm_set_rendering(id);
				// give a frag for a tackle
				cs_set_user_deaths(attacker,cs_get_user_deaths(attacker)+1);
				// set fumble status to one so it doesnt run again
				Fumblestat[0]++;
			}
			set_pev(id,pev_health,1000.0);
		}
	}
	return PLUGIN_CONTINUE;
}

// try and get a new game going
public start_game()
{
	// if there is a current game, cancel
	if (GameActive || dwnum != 0)
		return;
	// check to see if both teams have a player
	if (check_teams())
	{
		display_comment(13,0);
		GameActive = 1;
		StatSnap = 2;
		tscore = ctscore = PAT = 0;
		TeamWithBall = random_num(1,2);
		arrayset(Burst,1,get_maxplayers());
		if (TeamWithBall==1)
		{
			Scrimage_loc = Ttd_loc[0]-380;
			if (get_cvar_num("fm_kickoffs"))
			{
				Kicking = 2;
				FirstD_loc = 10000;
			}
			else
			{
				FirstD_loc = Scrimage_loc-450;
				reset_drive();
			}
		}
		else
		{
			
			Scrimage_loc = CTtd_loc[0]+380;
			if (get_cvar_num("fm_kickoffs"))
			{
				Kicking = 1;
				FirstD_loc = 10000;
			}
			else
			{
				FirstD_loc = Scrimage_loc+450;
				reset_drive();
			}
		}
		// check to see if fg are allowed
		if (!get_cvar_num("fm_fieldgoals"))
			FGallow = 0;
		// set game related tasks
		set_task(1.0,"revive");
		set_task(3.0,"act_reset");
		remove_task(5273333);
		remove_task(306);
		remove_task(80008);
		set_task(4.0,"create_fldlines",20504);
		set_task(0.3,"recure_sec",80008,_,_,"b");
	}
	else
	{
		// give players a ball to play around
		new Players[32],count=0,ent;
		while ((ent = engfunc(EngFunc_FindEntityByString,ent,"classname","grenade")) != 0)
			count++;
		if (count<50)
		{
			get_players(Players,ent,"a");
			for (new i=0;i<ent;i++)
				if (get_user_team(Players[i])!=3)
					give_item(Players[i],"weapon_hegrenade");
		}
		display_comment(12,0);
		// check for right players again
		remove_task(5273333);
		set_task(1.0,"revive");
		if (!Tourney)
			set_task(40.0,"start_game",5273333);
	}
}

// when the ball is snapped
public act_snap(id)
{
	if (!GameActive)
		return;
	// kill the snap counter
	remove_task(8675309);

	if (get_cvar_num("fm_rushclock") && !Kicking)
	{
		if (StatSnap)
		{
			NoRushing = 0;
			return;
		}
		else if (!fdtime && !NoRushing)
		{
			NoRushing = 1;
			fdtime = get_cvar_num("fm_rushclock") * -1;
			set_task(1.0,"display_timer",8675309,_,_,"b");
		}
	}

	StatSnap = 1;

	// play the hut wave
	client_cmd(0, "spk ^"football/hut.wav^" ");

	// snap message
	if (!Kicking && id != -1)
		display_comment(1,id);

	// display second white help message
	display_help(2);

	// set timer incase of an error somewhere
	remove_task(306);
	set_task(40.0,"play_over2",306);

	// get players ready to start the down
	new players[32],origin[3],num;
	get_players(players,num,"a");
	for (new i=0;i<num;i++) 
	{
		// leave spectators alone
		if (get_user_team(players[i])==3)
			continue;

		// un-freeze players
		get_user_origin(players[i],origin);
		if (origin[2] < CTtd_loc[2] && players[i] != FieldGoal)
		{
			// clear users velo so he doesnt fly away
			set_pev(players[i],pev_velocity,Float:{0.0, 0.0, 0.0});
			// set users height = ground
			origin[2] = CTtd_loc[2];
			set_user_origin(players[i],origin);
		}

		// screen flashes blue
		message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("ScreenFade"), _, players[i])
		write_short(3000)	// duration
		write_short(3000)	// hold time
		write_short(0)		// flags
		write_byte(0) 		// red
		write_byte(0)		// green
		write_byte(150) 	// blue
		write_byte(95)		// alpha
		message_end()

		// kill if they cross the line of scrimmage
		if (is_user_alive(players[i]) && !is_user_bot(players[i]))
		{
			if ((origin[0]<Scrimage_loc && get_user_team(players[i])==1) || (origin[0]>Scrimage_loc && get_user_team(players[i])==2))
			{
				// freeze player
				origin[0] = get_user_team(players[i])==1?Ttd_loc[0]+10:CTtd_loc[0]-10;
				origin[1] = CTtd_loc[1]+random_num(-600,600);
				origin[2] = CTtd_loc[2]-30;
				set_user_origin(players[i],origin);
				// say player is offside
				display_comment(15,players[i]);
				// tell them to use help messages cause they are noobs
				set_hudmessage(255, 255, 255, -1.0, -0.84, 0, 1.0, 12.0, 2.0, 2.0, -1);
				ShowSyncHudMsg(players[i], g_msghelp, "You have been moved for being offside. If you are unsure how to play, please read Your Help messages on the top of your screen during play.");
				// end play if carrier dies
				if (user_has_ball(players[i]))
				{
					play_over(2,0);
					// make player not glow
					fm_set_rendering(players[i]);
				}
			}
		}
	}
	// make ballcarrier tacklable now after the offsides
	setup_tackle();
}

// will call play_over becuase set_task is gay with arguments
public play_over2()
{
	play_over(2,0);
}

// after the pass 1=Complete 2=Incomplete 3=Good Kick 4=Bad Kick
public play_over(status,user)
{
	// if this function is already running, dont start again.
	if (!GameActive || StatSnap==2)
		return;

	// kill pre snap counter if play ends before the snap.
	if (task_exists(8675309))
		remove_task(8675309);

	// clear a few vars
	new Resettime = 4,change_pos;
	StatSnap = 2;
	fdtime = 0;
	CurDown++;
	arrayset(Fumblestat,0,2);

	if (status==1)
	{
		new origin[3];
		if (is_user_alive(user))
			get_user_origin(user,origin);
		if (FirstD_loc!=10000)// display yardage difference (if ! a pick)
			display_comment(19,floatround((Scrimage_loc-origin[0])/30.0));
		if (TeamWithBall==1)
		{
			if (origin[0]<=CTtd_loc[0] && PAT != 1)// touchdown check
			{
				display_comment(5,1);
				display_touchdown(1);
				client_cmd(0, "spk ^"football/cheer%d.wav^" ",random_num(1,6));
				act_lflash(user);
				tscore += (FGallow) ? 6 : 7;
				//add a td for player and td pass for qb to stats
				Stats[user][9]++;
				if (user != T_QB && FirstD_loc!=10000)
					Stats[T_QB][5]++;
				Resettime = 7;
				if (FGallow) 
				{
					PAT = 3;//set to three so it doesnt call this time
					Scrimage_loc = CTtd_loc[0]+150;
					FirstD_loc = Scrimage_loc-450;
				}
				else
					change_pos = 1;
			}
			else if (origin[0]<=CTtd_loc[0])// 2 point convert check
			{
				display_comment(41,1);
				display_touchdown(1);
				client_cmd(0, "spk ^"football/int.wav^" ");
				act_lflash(user);
				PAT = 0;
				tscore += 2;
				Resettime = 5;
				change_pos = 1;
			}
			else if (origin[0]>Ttd_loc[0] && !Kicking && FirstD_loc!=10000)// safety check
			{
				display_comment(25,1);
				display_touchdown(2);
				client_cmd(0, "spk ^"football/int.wav^" ");
				ctscore += 2;
				Resettime = 7;
				change_pos = 1;
			}
			else if (origin[0]<=FirstD_loc && FirstD_loc!=10000)// firstdown check
			{
				display_comment(7,user);
				CurDown = 1;
				Scrimage_loc = origin[0];
				FirstD_loc = Scrimage_loc-450;
				Resettime = 5;
			}
			else if (FirstD_loc==10000)// interception check
			{
				Scrimage_loc = origin[0];
				FirstD_loc = Scrimage_loc-450;
				Resettime = 5;
				reset_drive();
			}
			else// if they dont score or first down then new line of scrimmage
				Scrimage_loc = origin[0];
		}
		else
		{
			if (origin[0]>=Ttd_loc[0] && PAT != 2)// touchdown check
			{
				display_comment(5,2);
				display_touchdown(2);
				client_cmd(0, "spk ^"football/cheer%d.wav^" ",random_num(1,6));
				act_lflash(user);
				ctscore += (FGallow) ? 6 : 7;
				//add a td for player and td pass for qb to stats
				Stats[user][9]++;
				if (user != CT_QB && FirstD_loc!=10000)
					Stats[CT_QB][5]++;
				Resettime = 7;
				if (FGallow) 
				{
					PAT = 4;//set to four so it doesnt call this time
					Scrimage_loc = Ttd_loc[0]-150;
					FirstD_loc = Scrimage_loc+450;
				}
				else
					change_pos = 1;
			}
			else if (origin[0]>=Ttd_loc[0])// 2 point convert check
			{
				display_comment(41,2);
				display_touchdown(2);
				client_cmd(0, "spk ^"football/int.wav^" ");
				act_lflash(user);
				PAT = 0;
				ctscore += 2;
				Resettime = 5;
				change_pos = 1;
			}
			else if (origin[0]<CTtd_loc[0] && !Kicking && FirstD_loc!=10000)// safety check
			{
				display_comment(25,2);
				display_touchdown(1);
				client_cmd(0, "spk ^"football/int.wav^" ");
				tscore += 2;
				Resettime = 7;
				change_pos = 1;
			}
			else if (origin[0]>=FirstD_loc && FirstD_loc!=10000)// firstdown check
			{
				display_comment(7,user);
				CurDown = 1;
				Scrimage_loc = origin[0];
				FirstD_loc = Scrimage_loc+450;
				Resettime = 5;
			}
			else if (FirstD_loc==10000)// interception check
			{
				Scrimage_loc = origin[0];
				FirstD_loc = Scrimage_loc+450;
				Resettime = 5;
				reset_drive();
			}
			else// if they dont score or first down then new line of scrimmage
				Scrimage_loc = origin[0];
		}
	}
	// field goal is good
	else if (status==3)
	{
		new Float:origin[3];
		pev(user,pev_origin,origin);
		display_comment(37,floatround((Scrimage_loc-origin[0])/30.0));
		display_touchdown(TeamWithBall);
		client_cmd(0, "spk ^"football/int.wav^" ");
		act_lflash(pev(user,pev_iuser2));
		if (TeamWithBall==1)
			tscore += (PAT) ? 1 : 3;
		else
			ctscore += (PAT) ? 1 : 3;
		PAT = 0;
		Resettime = 5;
		change_pos = 1;
	}
	// kickoff is too short or not picked up
	else if (Kicking)
	{
		Scrimage_loc = (Ttd_loc[0]+CTtd_loc[0])/2;
		FirstD_loc = (TeamWithBall==1) ? Scrimage_loc+450 : Scrimage_loc-450;
		TeamWithBall = (TeamWithBall==1) ? 2 : 1;
		Kicking = 0;
		reset_drive();
	}
	// ball goes outta bounds on a kickoff
	else if (FirstD_loc==10000)
		reset_drive();
	// check for point after touchdown
	if (PAT)
		// check to see if it was initiated this play end
		if (PAT>2)// set up for PAT
		{
			PAT -= 2;
			CurDown = 1;
			arrayset(Burst,1,get_maxplayers());
		}
		// check to see if the PAT was initiated last play end
		else// failed to score on PAT
		{
			display_comment(40,PAT);
			TeamWithBall = PAT;// reset incase ball is picked and nonTD
			PAT = status = 0;// clear PAT and status so turnover doesnt trigger
			change_pos = 1;
		}
	// if we are kicking off or changing posession
	if (change_pos)
		if (get_cvar_num("fm_kickoffs"))
		{
			Kicking = (TeamWithBall==1) ? 2 : 1;
			Scrimage_loc = (TeamWithBall==1) ? Ttd_loc[0]-380 : CTtd_loc[0]+380;
			FirstD_loc = 10000;
			CurDown = 1;
			arrayset(Burst,1,get_maxplayers());
		}
		else
		{
			Scrimage_loc = (TeamWithBall==1) ? CTtd_loc[0]+380 : Ttd_loc[0]-380;
			FirstD_loc = (TeamWithBall==1) ? Scrimage_loc+450 : Scrimage_loc-450;
			TeamWithBall = (TeamWithBall==1) ? 2 : 1;
			reset_drive();
		}
	// turnover and missed kick check
	if (CurDown>get_cvar_num("fm_downs") || status==4)
	{
		FirstD_loc = (TeamWithBall==1) ? Scrimage_loc+450 : Scrimage_loc-450;
		TeamWithBall = (TeamWithBall==1) ? 2 : 1;
		Resettime = 5;
		if (status!=4)
			display_comment(8,0);// turnover on downs msg
		reset_drive();
	}
	// clear fieldgoal if still active
	if (FieldGoal)
		FieldGoal = 0;
	// update score on score board
	if (pev_valid(ScoreClock[0]))
	{
		if (pev_valid(ScoreClock[0]))
			set_pev(ScoreClock[0], pev_frame, float(tscore/10));
		if (pev_valid(ScoreClock[1]))
			set_pev(ScoreClock[1], pev_frame, float(tscore%10));
		if (pev_valid(ScoreClock[2]))
			set_pev(ScoreClock[2], pev_frame, float(ctscore/10));
		if (pev_valid(ScoreClock[3]))
			set_pev(ScoreClock[3], pev_frame, float(ctscore%10));
	}
	// check scores for a winner
	if (tscore>=get_cvar_num("fm_maxscore") || ctscore>=get_cvar_num("fm_maxscore"))
	{
		display_winner();
		display_comment(11,0);
		return;
	}
	// team ballancer
	new players[32],count,teams[5];
	get_players(players,count);
	if (!Tourney)
		for (new i=0;i<count;i++)
			teams[get_user_team(players[i])]++;
	// if ts have 2 more than cts
	if (teams[1]-teams[2]>1)
		act_switch(-2);
	// if cts have 2 more than ts
	else if (teams[2]-teams[1]>1)
		act_switch(-1);
	// if ts have 1 more than cts and up 3 tds
	else if ((teams[1]>teams[2]) && (tscore-ctscore>20))
		act_switch(-2);
	// if cts have 1 more than ts and up 3 tds
	else if ((teams[2]>teams[1]) && (ctscore-tscore>20))
		act_switch(-1);
	// if only 3 players, make offense have 2
	else if (get_cvar_num("fm_evenusers") && ((TeamWithBall==1 && teams[1]==1 && teams[2]==2) || (TeamWithBall==2 && teams[1]==2 && teams[2]==1)))
		act_switch(TeamWithBall==1 ? -1 : -2);
	// make sure the scrimmage lines dont go past the field
	if (Scrimage_loc>Ttd_loc[0]){
		display_comment(26,0);
		Scrimage_loc = Ttd_loc[0]-380;
		FirstD_loc = Scrimage_loc-450;
	}
	else if (Scrimage_loc<CTtd_loc[0]){
		display_comment(26,0);
		Scrimage_loc = CTtd_loc[0]+380;
		FirstD_loc = Scrimage_loc+450;
	}
	if (FirstD_loc>Ttd_loc[0] && FirstD_loc!=10000)
		FirstD_loc = Ttd_loc[0];
	else if (FirstD_loc<CTtd_loc[0] && FirstD_loc!=10000)
		FirstD_loc = CTtd_loc[0];
	// we are ready to rock another down
	set_task(0.5,"revive");
	set_task(float(Resettime),"act_reset");
}

// resets teams for a new down
public act_reset()
{
	// if this function is already running, dont start again
	if (fdtime>0)
		return;	

	// clear the snap count
	StatSnap = 0;

	// error timers
	remove_task(306);
	remove_task(34404);
	set_task(70.0,"play_over2",34404);

	// remove balls on the ground
	new ent;
	while ((ent = engfunc(EngFunc_FindEntityByString,ent,"classname","grenade")) != 0)
		engfunc(EngFunc_RemoveEntity,ent);

	// play the whistle blowing sound
	client_cmd(0, "spk ^"football/whistle.wav^" ");

	// make sure there is atleast 1 player on each team
	if (!check_teams())
	{
		GameActive = 0;
		display_comment(14,0);
		set_task(10.0,"start_game",5273333);
		return;
	}

	//reset all players
	new players[32],num,spawn_loc[3],cnt[5],user_team,x_loc,y_loc;
	get_players(players,num,"a");
	for (new i=0;i<num;i++)
	{
		// afk checker/changer
		if (!Tourney && get_cvar_num("fm_afktimer") && lastmove[players[i]] && get_gametime()-lastmove[players[i]]>get_cvar_num("fm_afktimer"))
		{
			cs_set_user_team(players[i],CS_TEAM_SPECTATOR);
			user_silentkill(players[i]);
			display_comment(30,players[i]);
		}
		// get users team and check if spec
		user_team = get_user_team(players[i]);
		if (user_team==3)
			continue;
		// strip them incase they have a ball
		strip_user_weapons(players[i]);
		// fix model if messed
		ev_models(players[i]);
		// add 1 play to stats
		Stats[players[i]][0]++;
		// set users speed
		set_user_maxspeed(players[i],float(get_cvar_num("fm_maxspeed")));
		// clear blue glow if its active
		if (pev(players[i],pev_rendermode)!=kRenderNormal)
			fm_set_rendering(players[i]);
		// teleport to new starting position
		switch (get_cvar_num("fm_freezeuser"))
		{
			case 1:spawn_loc[2] = CTtd_loc[2]-10;
			case 2:spawn_loc[2] = CTtd_loc[2]-25;
			case 3:spawn_loc[2] = (CTtd_loc[0]-Scrimage_loc>-350 || Ttd_loc[0]-Scrimage_loc<350) ? CTtd_loc[2] : CTtd_loc[2]-25;
			default:spawn_loc[2] = CTtd_loc[2];
		}
		if ((!T_QB || !is_user_alive(T_QB) || !(get_user_team(T_QB)==1)) && user_team==1)
			T_QB = players[i];
		else if ((!CT_QB || !is_user_alive(CT_QB) || !(get_user_team(CT_QB)==2)) && user_team==2)
			CT_QB = players[i];
		if ((players[i]==T_QB && user_team==1) || (players[i]==CT_QB && user_team==2))
		{
			if (user_team==TeamWithBall)
			{
				give_item(players[i],"weapon_hegrenade"); 
				fm_set_rendering(players[i],kRenderFxGlowShell,0,0,250,kRenderTransAlpha,255);
				set_user_maxspeed(players[i],100.0);
			}
			x_loc = 120;
			y_loc = 0;
			spawn_loc[2] = CTtd_loc[2];
		}
		else
		{
			cnt[user_team]++;
			x_loc = 50;
			if (user_team==Kicking)
			{
				spawn_loc[2] = CTtd_loc[2];
				switch (cnt[user_team])
				{
					case 1:{ y_loc = -150; x_loc = 400; }
					case 2:{ y_loc = 150; x_loc = 400; }
					case 3:{ y_loc = -350; x_loc = 800; }
					case 4:{ y_loc = 350; x_loc = 800; }
					case 5:{ y_loc = -150; x_loc = 1200; }
					case 6:{ y_loc = 150; x_loc = 1200; }
					case 7:{ y_loc = -350; x_loc = 1600; }
					case 8:{ y_loc = 350; x_loc = 1600; }
					case 9:{ y_loc = -150; x_loc = 1900; }
					case 10:{ y_loc = 150; x_loc = 1900; }
					case 11:{ y_loc = -350; x_loc = 2200; }
					case 12:{ y_loc = 350; x_loc = 2200; }
					default:{ y_loc = 0; x_loc = 0; }
				}
			}
			else
				switch (cnt[user_team])
				{
					case 1: y_loc = -500;
					case 2: y_loc = 500;
					case 3: y_loc = -400;
					case 4: y_loc = 400;
					case 5: y_loc = -300;
					case 6: y_loc = 300;
					case 7: y_loc = -200;
					case 8: y_loc = 200;
					case 9: y_loc = -100;
					case 10: y_loc = 100;
					case 11: y_loc = -50;
					case 12: y_loc = 50;
					default: y_loc = 0;
				}
		}
		if (user_team==Kicking)
			spawn_loc[0] = Kicking==1 ? Ttd_loc[0]-x_loc : CTtd_loc[0]+x_loc;
		else
			spawn_loc[0] = user_team==1 ? Scrimage_loc+x_loc : Scrimage_loc-x_loc;
		spawn_loc[1] = Ttd_loc[1]+y_loc;
		set_user_origin(players[i],spawn_loc);
	}
	// player offset checker and fixer
	NoRushing = (!Tourney && !Kicking && !PAT && ((TeamWithBall==1 && cnt[1]>cnt[2]) || (TeamWithBall==2 && cnt[2]>cnt[1])) && cnt[1]<get_cvar_num("fm_evenusers") && cnt[2]<get_cvar_num("fm_evenusers")) ? 1 : 0;
	if (NoRushing)
		display_comment(31,NoRushing);
	fdtime = get_cvar_num("fm_playclock");
	// players are all set and are ready to pre snap
	if (Kicking)
	{
		// display white help messages
		display_help(4);
		// display kicking message
		display_comment(22,0);
		// give 10 secs to throw it
		set_task(10.0,"play_over2",306);
	}
	else
	{
		// display white help messages
		display_help(1);
		//display down number
		display_comment(9,0);
		//start new down timer
		set_task(1.0,"display_timer",8675309,_,_,"b");
	}
}

// countdown timer for the play clock
public display_timer()
{
	switch (fdtime)
	{
		case 0: {
			set_hudmessage(150, 0, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, -1);
			ShowSyncHudMsg(0, g_msgsync, "  HUT!^n  HUT!");
		}
		case 1: {
			set_hudmessage(255, 128, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, -1);
			ShowSyncHudMsg(0, g_msgsync, "  Set!^n   %d  ", fdtime);
		}
		case 2: {
			set_hudmessage(150, 150, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, -1);
			ShowSyncHudMsg(0, g_msgsync, "  Down!^n   %d  ", fdtime);
		}
		case -1: {
			set_hudmessage(200, 0, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, -1);
			ShowSyncHudMsg(0, g_msgsync, "  RUSH!^n  RUSH!");
		}
		case -2: {
			set_hudmessage(200, 200, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, -1);
			ShowSyncHudMsg(0, g_msgsync, " RUSHERS!^n  SET!");
		}
		default: {
			set_hudmessage(0, 150, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, -1);
			ShowSyncHudMsg(0, g_msgsync, "%s Clock^n   %d  ", (fdtime>0)?"Play":"Rush",fdtime);
		}
	}

	if (fdtime == 0 || fdtime == -1)
	{
		act_snap(0);
		return;
	}

	fdtime = (fdtime>0) ? fdtime-1 : fdtime+1;
}

// initiates the lines and the scoreboard
public create_fldlines()
{
	if (GameActive)
	{
		//make scrimmage lines
		set_task(0.4,"create_line",9505);
		set_task(0.8,"create_line",9506);

		//random chance to update stats
		if (!random_num(0,75))
			for (new b=0;b<get_maxplayers();b++)
				stats_save(b);

		// do it again
		remove_task(20504);
		set_task(3.0,"create_fldlines",20504);
	}
}

// puts the first down and line of scrimmage on the map
public create_line(id)
{
	static loc,clrs[3];
	loc  = (id == 9506) ? FirstD_loc : Scrimage_loc;
	clrs = (id == 9506) ? { 255, 255, 0 } : { 0, 0, 255 };

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(0)		//TE_BEAMPOINTS
	write_coord(loc)	//centerpoint
	write_coord(Ttd_loc[3] ? CTtd_loc[1]+Ttd_loc[3] : CTtd_loc[1]+1000)//left top corner
	write_coord(CTtd_loc[2]-34)	//horizontal height
	write_coord(loc)		//centerpoint
	write_coord(Ttd_loc[3] ? Ttd_loc[1]-Ttd_loc[3] : Ttd_loc[1]-1000)//left right corner
	write_coord(CTtd_loc[2]-34)	//horizontal height
	write_short(spr[0])	//sprite to use
	write_byte(1)		// framestart
	write_byte(1)		// framerate
	write_byte(42)		// life in 0.1's
	write_byte(15)		// width
	write_byte(0)		// noise
	write_byte(clrs[0])	// red
	write_byte(clrs[1])	// green
	write_byte(clrs[2])	// blue
	write_byte(210)		// brightness
	write_byte(0)		// speed
	message_end()
}

// if one team scores a touchdown make their screen flash
public display_touchdown(team)
{
	new players[32],num,clr[3];
	get_players(players,num,"a");
	for (new i=0;i<num;i++) 
	{
		clr = (get_user_team(players[i])==team) ? {0,170,0} : {170,0,0};
		// screen flashes
		message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("ScreenFade"),_,players[i]);
		write_short(3000);	// duration
		write_short(3000);	// hold time
		write_short(0);		// flags
		write_byte(clr[0]);	// red
		write_byte(clr[1]);	// green
		write_byte(clr[2]);	// blue
		write_byte(95);		// alpha
		message_end();
	}
}

// if one teams wins
public display_winner()
{
	new twinner[22],clr[3],players[32],num;
	dwnum++;
	dwnum2++;
	GameActive=StatSnap=PAT=Kicking=FieldGoal=NoRushing=TeamWithBall=fdtime = 0;
	if (task_exists(8675309)) remove_task(8675309);

	switch (random_num(1,7))
	{
		case 1: clr = {255,0,0};
		case 2: clr = {0,255,0};
		case 3: clr = {0,0,255};
		case 4: clr = {255,255,0};
		case 5: clr = {0,255,255};
		case 6: clr = {255,0,255};
		case 7: clr = {255,255,255};
	}
	formatex(twinner, 20, (tscore>ctscore) ? "TERRORISTS" : "COUNTER-TERRORISTS");

	// display messages and colours
	display_touchdown(dwnum2);
	set_hudmessage(clr[0], clr[1], clr[2], -0.8452, -0.84, 0, 1.0, 12.0, 0.0, 0.0, -1);
	ShowSyncHudMsg(0, g_msgsboard, "   %s^n        WIN!!^n      %d       %d",twinner,ctscore,tscore);
	set_hudmessage(clr[0], clr[1], clr[2], -1.0, 0.80, 0, 1.0, 10.0, 0.01, 0.01, -1);
 	ShowSyncHudMsg(0, g_msgsync, "GAME OVER!");

	// repeat win message
	if (dwnum<20)
		set_task(0.5,"display_winner");
	else
	{
		dwnum = 0;
		// respawn them and give them some balls
		get_players(players,num,"ch");
		for (new i=0;i<num;i++)
			if (get_user_team(players[i])==1 || get_user_team(players[i])==2)
			{
				spawn(players[i]);
				give_item(players[i],"weapon_hegrenade");
			}
		if (!Tourney)
		{
			// give them 30secs to play
			set_task(30.0,"start_game",5273333);
			// mix teams if one gets owned
			if ((tscore>=get_cvar_num("fm_maxscore") || ctscore>=get_cvar_num("fm_maxscore")) && (tscore<10 || ctscore<10))
				teams_shake();
		}
	}
	if (dwnum2==2)
		dwnum2 = 0;
}

// display a game related message in green
public display_comment(type,user)
{
	new name[32];
	if (is_user_connected(user))
	{
		get_user_name(user,name,15);
		Stats[user][12] = player_rating(user);
		formatex(name,31,"%s \o(%d)",name,Stats[user][12]);
	}

	switch (type)
	{
		case 1: {//ball is snapped
			if (user)
				switch(random_num(1,6))
				{
					case 1: client_printc(0,"\t%s\g takes the snap and sits back in the pocket.",name);
					case 2: client_printc(0,"\t%s\g snaps the ball",name);
					case 3: client_printc(0,"\t%s\g gets the snap and looks down field.",name);
					case 4: client_printc(0,"\gThe ball is snapped and \t%s\g gets in position to make a throw.",name);
					case 5: client_printc(0,"\t%s\g calls hut and fades back with the pigskin.",name);
					case 6: client_printc(0,"\t%s\g snaps the ball and the play starts.",name);
				}
			else
				client_printc(0,"\gThe ball is snapped and play has begun.");
		}
		case 2: {//ball is thrown
			if (user)
			{
				//add a throw to stats
				Stats[user][3]++;
				switch(random_num(1,7))
				{
					case 1: client_printc(0,"\t%s\g spots a receiver and tosses him the ball.",name);
					case 2: client_printc(0,"\gThe ball is thrown by \t%s\g!",name);
					case 3: client_printc(0,"\t%s\g winds up and throws a long bomb.",name);
					case 4: client_printc(0,"\t%s\g hits an open receiver with a pass.",name);
					case 5: client_printc(0,"\t%s\g fakes to one side and throws to the other.",name);
					case 6: client_printc(0,"\gThe QB \t%s\g throws a bomb, deep!",name);
					case 7: client_printc(0,"\t%s\g throws up the hailmary!",name);
				}
			}
			else
				client_printc(0,"\gThe ball is snapped and play has begun.");
		}
		case 3: {//tackled
			//add a tackle to stats
			Stats[user][7]++;
			switch(random_num(1,4))
			{
				case 1: client_printc(0,"\t%s\g makes the tackle.",name);
				case 2: client_printc(0,"\t%s\g takes down the ball carrier.",name);
				case 3: client_printc(0,"\t%s\g makes a play and tags the receiver.",name);
				case 4: client_printc(0,"\gThe tackle is made by \t%s\g!",name);
			}
		}
		case 4: {//incomplete
			if (user)
			{
				//add a thrownto to stats
				Stats[user][2]++;
				switch(random_num(1,4))
				{
					case 1: client_printc(0,"\t%s\g can't come up with the ball.",name);
					case 2: client_printc(0,"\t%s\g can't get to the pass.",name);
					case 3: client_printc(0,"\t%s\g missed the pass.",name);
					case 4: client_printc(0,"\t%s\g misreads the pass and misses the ball.",name);
				}
			}
			else
				switch(random_num(1,3))
				{
					case 1: client_printc(0,"\gThe ball is thrown incomplete!");
					case 2: client_printc(0,"\gThe QB throws the ball away.");
					case 3: client_printc(0,"\gThe pass is over-thrown and incomplete.");
				}
		}
		case 5: {//touchdown
			if (TeamWithBall==1)
				client_printc(0,"\gTOUCHDOWN TERRORISTS!");
			else
				client_printc(0,"\gTOUCHDOWN COUNTER-TERRORISTS!");
		}
		case 6: {//interception
			switch(random_num(1,4))
			{
				case 1: client_printc(0,"\t%s\g picks off the pass.",name);
				case 2: client_printc(0,"\gThe ball has been intercepted by \t%s\g!",name);
				case 3: client_printc(0,"\t%s\g intercepts the pass and goes the other way.",name);
				case 4: client_printc(0,"\t%s\g reads the play and picks off the pass.",name);
			}
		}
		case 7: {//first down
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\g First down \t%s\g!",name);
				case 2: client_printc(0,"\t%s\g gets the ball to the first down line!",name);
				case 3: client_printc(0,"\t%s\g takes the ball over the first down line.",name);
			}
		}
		case 8: {//turnover on downs
			new tname[20];
			formatex(tname, 20, (TeamWithBall==1) ? "Terrorists" : "Counter-Terrorists");
		
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\gThe ball is turned over by the \t%s\g on downs!",tname);
				case 2: client_printc(0,"\gThe \t%s\g failed to get the first down and the ball is turned-over.",tname);
				case 3: client_printc(0,"\gThe \t%s\g loose possession of the ball on downs.",tname);
			}
		}
		case 9: {//down print
			new tname[20];
			formatex(tname, 20, (TeamWithBall==1) ? "Terrorists" : "Counter-Terrorists");

			if (PAT)
				client_printc(0,"\t%s\g set up for the point after TD.",tname);
			else
				switch(CurDown)
				{
					case 1: client_printc(0,"\t%dst\g down for \t%s\g!",CurDown,tname);
					case 2: client_printc(0,"\t%dnd\g down for \t%s\g!",CurDown,tname);
					case 3: client_printc(0,"\t%drd\g down for \t%s\g!",CurDown,tname);
					default: client_printc(0,"\t%dth\g down for \t%s\g!",CurDown,tname);
				}
		}
		case 10: {//ball caught
			//add a catch and thrownto to stats
			Stats[user][1]++;
			Stats[user][2]++;
			switch(random_num(1,6))
			{
				case 1: client_printc(0,"\t%s\g hauls in the pass!",name);
				case 2: client_printc(0,"\gThe pass is caught by \t%s\g!",name);
				case 3: client_printc(0,"\t%s\g makes a nice grab!",name);
				case 4: client_printc(0,"\t%s\g snags the ball!",name);
				case 5: client_printc(0,"\t%s\g completes the pass!",name);
				case 6: client_printc(0,"\gThe ball is caught by \t%s\g and moves up-field.",name);
			}
		}
		case 11: {//gameover
			if (tscore>ctscore)
				client_printc(0,"\g TERRORISTS WIN!");
			else
				client_printc(0,"\g COUNTER-TERRORISTS WIN!");
		}
		case 12: {//not enough players
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\g A game will start once there are is a player on each team. If you need help, type /help in chat.");
				case 2: client_printc(0,"\g We are currently waiting for each team to have a player, so we can start. For help, type /help in chat.");
			}
		}
		case 13: {//new game
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\g A new game is about to begin!");
				case 2: client_printc(0,"\g A new game is starting!");
			}
		}
		case 14: {//game caned
			client_printc(0,"\gThis game has been cancelled due to one team not having a player!");
		}
		case 15: {//offside
			client_printc(0,"\t%s\g crossed the srimmage line before the snap!\t MAKE SURE YOU READ -=YOUR HELP=-!!",name);
		}
		case 16: {//make new qb
			if (get_user_team(user)==1)
				client_printc(0,"\t%s \gis the new\t Terrorist\g QB.",name);
			else
				client_printc(0,"\t%s \gis the new\t Counter-Terrorist\g QB.",name);
		}
		case 17: {//switch player team
			new tname[20];
			if (get_user_team(user)==1)
				formatex(tname, 20, "Terrorists");
			else
				formatex(tname, 20, "Counter-Terrorists");
			client_printc(0,"\t%s\g has been switch to the \t%s\g!\t Say /switch to change teams.",name,tname);
		}
		case 18: {//player rushed
			client_printc(0,"\t%s\g tried to Rush the Scrimmage Line but it's currently disabled.",name);
		}
		case 19: {//yards gained
			new tname[20],dir;
			if (TeamWithBall==1) {
				formatex(tname, 20, "Terrorists");
				dir = (user>0) ? random_num(1,2) : random_num(3,4);
			}
			else {
				formatex(tname, 20, "Counter-Terrorists");
				dir = (user>0) ? random_num(3,4) : random_num(1,2);
			}
			if (!user) dir = 5;
			else if (user<0) user *= -1;
			switch (dir)
			{
				case 1: client_printc(0,"\t%s\g gained \t%d\g %s on the play!",tname,user,(user==1)?"yard":"yards");
				case 2: client_printc(0,"\t%s\g got a total of \t%d\g %s.",tname,user,(user==1)?"yard":"yards");
				case 3: client_printc(0,"\t%s\g lost \t%d\g %s on the play!",tname,user,(user==1)?"yard":"yards");
				case 4: client_printc(0,"\t%s\g were taken back \t%d\g %s on the play!",tname,user,(user==1)?"yard":"yards");
				case 5: client_printc(0,"\t%s\g gained no yards on the play.",tname);
			}
		}
		case 20: {//short kick
			new tname[20];
			formatex(tname, 20, (TeamWithBall==1) ? "Terrorists" : "Counter-Terrorists");

			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g kicked the ball too short!",tname);
				case 2: client_printc(0,"\t%s\g kicked the ball under %d yards.",tname,get_cvar_num("fm_kickminlen"));
			}
		}
		case 21: {//mix teams
			client_printc(0,"\g All the players have been randomly mixed together!");
		}
		case 22: {//kicking
			new tname[20],tname2[20];
			if (TeamWithBall==1){
				formatex(tname, 20, "Terrorists");
				formatex(tname2, 20, "Counter-Terrorists");
			}else{
				formatex(tname, 20, "Counter-Terrorists");
				formatex(tname2, 20, "Terrorists");
			}
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g will be kicking to the \t%s\g!",tname,tname2);
				case 2: client_printc(0,"\t%s\g are kicking off to the waiting \t%s\g.",tname,tname2);
			}
		}
		case 23: {//pickup random ball
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\t%s\g has recovered the ball!",name);
				case 2: client_printc(0,"\gThe ball is received by \t%s\g!",name);
				case 3: client_printc(0,"\t%s\g picks the ball off the ground.",name);
			}
		}
		case 24: {//ball still alive
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\gThe ball landed behind the line and is still active.");
				case 2: client_printc(0,"\gThe ball is still alive!");
				case 3: client_printc(0,"\gThe ball never cross the scrimage line and is active.");
			}
		}
		case 25: {//safety
			if (TeamWithBall==1)
				client_printc(0,"\gSAFETY ON THE TERRORISTS!");
			else
				client_printc(0,"\gSAFETY ON THE COUNTER-TERRORISTS!");
		}
		case 26: {//touchback
			if (TeamWithBall==1)
				client_printc(0,"\gTouchback Terrorists!");
			else
				client_printc(0,"\gTouchback Counter-Terrorists!");
		}
		case 27: {//cause fumble
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\t%s\g strips the ball!",name);
				case 2: client_printc(0,"\t%s\g forces a fumble!",name);
				case 3: client_printc(0,"\t%s\g stripped the ball causing a fumble!",name);
			}
		}
		case 28: {//good pitch
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\t%s\g pitches the ball back.",name);
				case 2: client_printc(0,"\t%s\g pitches the ball to a teammate.",name);
				case 3: client_printc(0,"\t%s\g laterals the football!",name);
			}
		}
		case 29: {//bad pitch
			switch(random_num(1,3))
			{
				case 1: client_printc(0,"\t%s\g ends the play with a forward pitch.",name);
				case 2: client_printc(0,"\t%s\g ends the play with a forward lateral.",name);
				case 3: client_printc(0,"\t%s\g pitches the ball forward and ends the play.",name);
			}
		}
		case 30: {//player afk
			client_printc(0,"\t%s\g has been switch to \tSpectator\g for being AFK. \t(say /switch to comeback)",name);
		}
		case 31: {//rushing change
			client_printc(0,"\gRushing is now \o%s\g.",(user) ? "disabled" : "enabled");
		}
		case 32: {//player goes outta bounds
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g has run out of bounds.",name);
				case 2: client_printc(0,"\t%s\g is forced out of bounds.",name);
			}
		}
		case 33: {//field goal
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g sets up for a field goal.",name);
				case 2: client_printc(0,"\t%s\g gets in position to kick a field goal.",name);
			}
		}
		case 34: {//ball outta
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\gThe ball has gone out of bounds.");
				case 2: client_printc(0,"\gThe plays ends with the ball out of bounds.");
			}
		}
		case 35: {//tourney mode toggle
			client_printc(0,"\t%s\g sets Tournament/Scrim mode: \o%s\g.",name,(Tourney) ? "enabled" : "disabled");
		}
		case 36: {//field goal kicked
			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g boots the ball with \t%d%% \gpower.",name,floatround(FGstat[1]));
				case 2: client_printc(0,"\t%s\g kickes the field goal with \t%d%% \gvelocity.",name,floatround(FGstat[1]));
			}
		}
		case 37: {//field goal good
			if (user<0) user *= -1;
			if (!PAT)
				switch(random_num(1,2))
				{
					case 1: client_printc(0,"\gThe kick is good from \t%d \gyards!",user);
					case 2: client_printc(0,"\gThe \t%d \gyard kick is good!",user);
				}
			else
				client_printc(0,"\gThe point after TD kick is good!");
		}
		case 38: {//field goal bad
			client_printc(0,"\gThe kick by \t%s\g is no good.",name);
		}
		case 39: {//field goal int
			client_printc(0,"\t%s\g gets the failed field goal attempt!",name);
		}
		case 40: {//PAT fail
			new tname[20];
			formatex(tname, 20, (user==1) ? "Terrorists" : "Counter-Terrorists");

			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g failed to score on the PAT.",tname);
				case 2: client_printc(0,"\t%s\g were unable to score on the point after TD.",tname);
			}
		}
		case 41: {//2 point convert
			new tname[20];
			formatex(tname, 20, (user==1) ? "Terrorists" : "Counter-Terrorists");

			switch(random_num(1,2))
			{
				case 1: client_printc(0,"\t%s\g completed the \t2 \gpoint convert!",tname);
				case 2: client_printc(0,"\t%s\g scored on the \t2 \gpoint conversion!",tname);
			}
		}
	}
}

// display a game related message in orange
public display_help(type)
{
	if (!get_cvar_num("fm_helpmsg"))
		return;
	new mssge[200],players[32],count;
	get_players(players,count,"a");
	for (new i=0;i<count;i++)
	{
		if (get_user_team(players[i])==TeamWithBall)
		{
			if (players[i]==CT_QB || players[i]==T_QB)
				switch (type)
				{
					case 1: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Quarterback=-^nDo NOT cross the blue line until the ball is snapped/hutted. Get into position to either throw or run the football while wait for the snap.");
					case 2: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Quarterback=-^nNow either sitback and throw to an open receiver or try and rush the ball over the first down line.");
					case 3: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Quarterback=-^nNow you can try and block for the ball-carrier, or if he is behind the scrimmage line try and get open for a pass.");
					case 4: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Kicker=-^nThrow the ball down-field and either try to receive the ball or tackle the ball-carrier");
				}
			else
				switch (type)
				{
					case 1: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Receiver=-^nWait for the ball to be snapped/hutted.");
					case 2: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Receiver=-^nNow you can run up-field and try and get open for a pass from the QB.");
					case 3: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Receiver=-^nIf you have the ball, you can try and outrun the defenders, or if you don't have the ball you can block defenders.");
					case 4: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Tackler=-^nWait for the ball to be kicked then run down-field to try and cover the ball or tackle the ball-carrier.");
				}
		}
		else
		{
			if (players[i]==CT_QB || players[i]==T_QB)
				switch (type)
				{
					case 1: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Safety=-^nDo NOT cross the blue line until the ball is snapped/hutted. Your responsibiliy is to cover the QB, stay close to him.");
					case 2: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Safety=-^nNow that the ball is snapped you can either rush the QB or cover a receiver or play zone defense and try and pick the ball.");
					case 3: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Safety=-^nNow it is your responsibility to stop the ball-carrier or to try and intercept the football.");
					case 4: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Receiver=-^nGet in position and wait for the ball to be kicked. Once its kicked try and cover the ball.");
				}
			else
				switch (type)
				{
					case 1: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Defensiveback=-^nSit and wait for the QB to snap/hut the football.");
					case 2: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Defensiveback=-^nNow that the ball is snapped you can either rush the QB or you can most likely cover a Receiver and try and pick the ball.");
					case 3: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Defensiveback=-^nIf the ball is caught you need to tackle the ball-carrier or if the ball is in the air you can try and pick it off.");
					case 4: formatex(mssge, 192, "-=YOUR HELP=-  -=POSITION: Receiver=-^nGet in position and wait for the ball to be kicked. Once its kicked try and cover the ball.");
				}
		}
		set_hudmessage(255, 128, 0, -1.0, -0.84, 1, 1.0, 10.0, 0.5, 0.5, -1);
		ShowSyncHudMsg(players[i], g_msghelp, "%s", mssge);
	}
}

// makes a motd on how to play
public display_info(id)
{
	new mssge[1800],iLen;
	iLen = format(mssge, 1800, "<style>body{background-color:black;color:white;font-family:verdana}a{color:white}</style><center><h1>American Football Mod</h1>Created by: WhooKid (travomail@gmail.com)<br><a href=http://forums.alliedmods.net/showthread.php?t=63165>Get this mod here</a>");
	iLen += format(mssge[iLen], 1800 - iLen, "<table><tr><td><u>Commands</u><br><font size=2><li><b>to catch</b> - <i>let the ball hit you</i></li><li>say <b>/qb</b> - <i>Make you the QB of your team</i></li><li>say <b>/start</b> - <i>Starts a new Football game</i></li><li>say <b>/switch</b> - <i>Switches a player to the opposite team</i></li>");
	iLen += format(mssge[iLen], 1800 - iLen, "<li>press <b>+USE key (default 'e')</b> - <i>Activates Speed Burst (allowed 1 per drive)</i></li><li>press <b>+RELOAD key (default 'r')</b> - <i>Laterals the ball (no forward laterals)</i></li><li>press <b>radio1 key (default 'z')</b> - <i>Initiate a Field Goal kick</i></li>");
	iLen += format(mssge[iLen], 1800 - iLen, "<li>say <b>/top 'stat'</b> (ex. /top catches) - <i>Displays top stat leaders.</i></li><li>say <b>/topqb 'stat'</b> (ex. /topqb passes) - <i>Displays top quarterback stat leaders.</i></li><li>say <b>/stats</b> - <i>Displays your current stats.</i></li><li>say <b>/resetstats</b> - <i>Resets all your stats to zero.</i></li></table>");
	show_motd(id,mssge,"Football Help");
}

// makes the ball gradually slow down.
public slow_ball(id)
{
	id -= 6000;
	if (!pev_valid(id)) return;
	new Float:cur_velo[3],velo_decr = 70;
	pev(id,pev_velocity,cur_velo);
	if (pev(id,pev_owner)) set_pev(id,pev_owner,0);
	if (cur_velo[0]!=0 || cur_velo[1]!=0)
	{
		if (pev(id,pev_flags) & FL_ONGROUND)
		{
			if (cur_velo[0]<velo_decr && cur_velo[0]>-velo_decr && cur_velo[1]<velo_decr && cur_velo[1]>-velo_decr)
			{
				set_pev(id,pev_velocity,Float:{0.0,0.0,0.0});
				set_pev(id,pev_gravity,1.0);
				return;
			}
			else
			{
				for (new a=0;a<2;a++)
					if (cur_velo[a]>velo_decr) cur_velo[a] -= velo_decr;
					else if (cur_velo[a]<-velo_decr) cur_velo[a] += velo_decr;
					else cur_velo[a] = 0.0;
			}
			set_pev(id,pev_velocity,cur_velo);
		}
		set_task(0.5,"slow_ball",id+6000);
	}
}

// weapon info changes
public ev_models(id) 
{
	if (is_user_alive(id))
	{
		if (user_has_ball(id))
		{
			set_pev(id,pev_viewmodel2,"models/v_football.mdl");
			set_pev(id,pev_weaponmodel2,"models/p_football.mdl");
		}
		else
		{
			set_pev(id,pev_viewmodel2,"models/v_hands.mdl");
			set_pev(id,pev_weaponmodel2,"models/p_hands.mdl");
		}
		set_pev(id,pev_weaponanim,3);
	}
	return PLUGIN_CONTINUE;
}

// fire in the hole sound
public msg_sendaudio() 
{
	new string[32];
	get_msg_arg_string(2,string,31);
	// stop grenade throwing radio alerts
	if (equali(string,"%!MRAD_FIREINHOLE"))
		return PLUGIN_HANDLED;
	return PLUGIN_CONTINUE;
}

// fire in the hole message AND weapon cannot be dropped message
public msg_textmsg() 
{
	new string[32];
	// "This weapon cannot be dropped"
	get_msg_arg_string(2,string,31);
	if (equali(string,"#Weapon_Cannot_Be_Dropped"))
		return PLUGIN_HANDLED;
	// some exception thingy
	if (str_to_num(string) > 0 && get_msg_args() > 2)
	{
		// if it's a radio message
		get_msg_arg_string(3,string,31);
		if (equali(string,"#Game_radio"))
		{
			// "Fire in the hole!"
			get_msg_arg_string(5,string,31);
			if (equali(string,"#Fire_in_the_hole"))
				return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

// when a granade is thrown
public pfn_think(ent)
{
	new model[32];
	pev(ent,pev_model,model,31);
	// make sure its a henade/ball
	if (!equali(model,"models/w_football.mdl") || !Football)
		return PLUGIN_CONTINUE;
	// stop grenade from blowing up
	return PLUGIN_HANDLED;
}

// change mod name
public fw_gamedesc()
{
	forward_return(FMV_STRING,PLUGIN);
	return FMRES_SUPERCEDE;
}

// set ball world model
public fw_setmodel(ent,model[]) 
{
 	// change grenades to footballs
	if (equali(model,"models/w_hegrenade.mdl")) 
	{
		engfunc(EngFunc_SetModel,ent,"models/w_football.mdl");
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}

// check everytime someone presses a button
public fw_start(const id,const uc_handle)
{
	static buttons,oldbuttons;
	buttons = get_uc(uc_handle,UC_Buttons);
	if (is_user_alive(id) && buttons)
	{
		lastmove[id] = get_gametime();
		oldbuttons = pev(id,pev_oldbuttons);
		if (buttons & IN_USE && !(oldbuttons & IN_USE) && get_cvar_num("fm_allowburst") && !Burst[id])
			act_burst(id);
		if (buttons & IN_RELOAD && !(oldbuttons & IN_RELOAD) && user_has_ball(id) && (StatSnap || !GameActive))
			act_pitch(id);
		if (buttons & IN_ATTACK2 && !(oldbuttons & IN_ATTACK2) && fdtime<get_cvar_num("fm_playclock") && fdtime>0 && (id==CT_QB||id==T_QB) && user_has_ball(id) && !StatSnap)
			act_snap(id);
		if (buttons & IN_ATTACK && !(oldbuttons & IN_ATTACK) && FieldGoal==id && GameActive)
			fieldgoal_att(id);
	}
	return FMRES_IGNORED;
}

// initiate the players speed burst
public act_burst(id)
{
	Burst[id] = 1;

	new origin[3];
	get_user_origin(id,origin);
	origin[2] -= 26;
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(12);
	write_coord(origin[0]);
	write_coord(origin[1]);
	write_coord(origin[2]);
	write_byte(188);
	write_byte(10);
	message_end();

	act_trail(id+905);
}

// execute the speed burst on the player
public act_trail(id)
{
	id -= 905;
	if (!is_user_alive(id))
		return;

	new clr[3],scenario[15];
	BrsCnt[id]--;

	reset_icons(id);
	formatex(scenario,14,"number_%d",BrsCnt[id]);
	message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusIcon"),_,id);
	write_byte(1);
	write_string(scenario);
	write_byte(0);
	write_byte(150);
	write_byte(0);
	message_end();
	
	if (BrsCnt[id]>0)
	{
		clr = (get_user_team(id)==1) ? {150,0,0} : {0,0,150};
		set_user_maxspeed(id,float(user_has_ball(id)?get_cvar_num("fm_burstspeed")-30:get_cvar_num("fm_burstspeed")));
		if (BrsCnt[id]>4)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
			write_byte(TE_BEAMFOLLOW);
			write_short(id);
			write_short(spr[0]);
			write_byte(15);
			write_byte(8);
			write_byte(clr[0]);
			write_byte(clr[1]);
			write_byte(clr[2]);
			write_byte(255);
			message_end();
		}
		set_task(1.0,"act_trail",id+905);
	}
	else
	{
		set_user_maxspeed(id,float(user_has_ball(id)?get_cvar_num("fm_maxspeed")-30:get_cvar_num("fm_maxspeed")));
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
		write_byte(TE_KILLBEAM);
		write_short(id);
		message_end();
	}
}

// initiate a pitch
public act_pitch(id)
{
	if (get_cvar_num("fm_allowpitch") && !(GameActive && Kicking && !StatSnap))
	{
		cs_set_user_bpammo(id,CSW_HEGRENADE,0);
		/*new ent;
		while ((ent = engfunc(EngFunc_FindEntityByString,ent,"classname","grenade")) != 0)
			if (pev(ent,pev_owner)==id)
				return;*/
		new ball = make_ball(id),torigin[3],Float:eorigin[3],Float:diff[3],Float:velocity[3],Float:angles[3];
	
		get_user_origin(id,torigin,3);
		pev(ball,pev_origin,eorigin);
		pev(id,pev_angles,angles);
		//pev(id,pev_velocity,velocity);
		for (new a=0;a<3;a++)
			diff[a] = torigin[a] - eorigin[a];
		new Float:length = floatsqroot(floatpower(diff[0], 2.0) + floatpower(diff[1], 2.0) + floatpower(diff[2], 2.0));
		velocity[0] += diff[0] * (400.0 / length);
		velocity[1] += diff[1] * (400.0 / length);
		velocity[2] += diff[2] * (400.0 / length)+300.0;
		set_pev(ball,pev_velocity,velocity);

		// show draw animation
		message_begin(MSG_ONE,SVC_WEAPONANIM,_,id);
		write_byte(3);
		write_byte(0);
		message_end();

		if (!GameActive || StatSnap==2)
			return;
		else if (((angles[1]>90 || angles[1]<-90) && get_user_team(id)==1) || (angles[1]<=90 && angles[1]>=-90  && get_user_team(id)==2))
		{
			set_pev(ball,pev_iuser1,1);
			remove_task(306);
			set_task(15.0,"play_over2",306);
			display_comment(29,id);
			play_over(1,id);
		}
		else
			display_comment(28,id);
	}
}

// initiate a field goal
public act_fieldgoal(id)
{
	if (!GameActive || !FGallow)
		return PLUGIN_CONTINUE;

	new Float:origin[3];
	pev(id,pev_origin,origin);
	if (FieldGoal || !user_has_ball(id) || StatSnap==2 || FirstD_loc==10000 || (origin[0]<Scrimage_loc && get_user_team(id)==1) || (origin[0]>Scrimage_loc && get_user_team(id)==2))
		return PLUGIN_HANDLED;

	FieldGoal = id;
	strip_user_weapons(id);
	origin[2] = (pev(id,pev_button) & IN_DUCK) ? CTtd_loc[2]-24.0 : CTtd_loc[2]-10.0;
	set_pev(id,pev_origin,origin);
	set_pev(id,pev_velocity,Float:{0.0, 0.0, 0.0});

	if (!StatSnap)// start play if it hasnt already
		act_snap(-1);

	fieldgoal_recure();
	remove_task(306);
	set_task(15.0,"play_over2",306);
	display_comment(33,id);

	return PLUGIN_HANDLED;
}

// display the kicking power bar for kicker
public fieldgoal_recure()
{
	if (!GameActive || !FieldGoal) return;

	// make bar
	new players[32],num;
	get_players(players,num,"a");
	for (new i=0;i<num;i++)
	{
		message_begin(MSG_ONE_UNRELIABLE,108,_,players[i]);
		write_short(1);
		message_end();
	}

	FGstat[0] = get_gametime();
	
	set_task(1.0,"fieldgoal_recure");
}

// kick the ball now that the kicker is ready
public fieldgoal_att(id)
{
	// calc kick power %
	FGstat[1] = ((get_gametime()-FGstat[0])*100.0)-5.0;
	if (FGstat[1]>100.0) FGstat[1] = 100.0;
	else if (FGstat[1]<0.0) FGstat[1] = 0.0;

	// spawn and kick ball
	new ball = make_ball(id),Float:diff[3],Float:angles[3],Float:velocity[3],Float:height = random_float(1070.0,1170.0) + (FGstat[1]);
	pev(id,pev_v_angle,angles);
	diff[0] = floatcos(angles[1],degrees) * height;
	diff[1] = floatsin(angles[1],degrees) * height;
	diff[2] = height;
	new Float:length = floatsqroot(floatpower(diff[0], 2.0) + floatpower(diff[1], 2.0) + floatpower(diff[2], 2.0));
	for (new a=0;a<3;a++)
		velocity[a] = diff[a] * ((600.0 + (FGstat[1] * 5.0) - random_float(0.0,15.0)) / length);
	set_pev(ball,pev_velocity,velocity);
	set_pev(ball,pev_iuser1,0);
	set_pev(ball,pev_iuser2,id);

	FieldGoal = 0;
	display_comment(36,id);
	ev_models(id);
	
	// unbury player
	new Float:origin[3];
	pev(id,pev_origin,origin);
	origin[2] = float(CTtd_loc[2]);
	set_pev(id,pev_origin,origin);

	// show kicking animation
	message_begin(MSG_ONE,SVC_WEAPONANIM,_,id);
	write_byte(5);
	write_byte(0);
	message_end();
	
	// clear bar
	new players[32],num;
	get_players(players,num,"a");
	for (new i=0;i<num;i++)
	{
		message_begin(MSG_ONE_UNRELIABLE,108,_,players[i]);
		write_short(0);
		message_end();
	}
}

// admin can assign any player to a qb
public set_qb(id,level,cid)
{
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED;

	new arg[32],name[32],name2[32];
	read_argv(1,arg,31);
	new player = cmd_target(id, arg, 2);
	if (!player)
		return PLUGIN_HANDLED
	get_user_name(id,name,31);
	get_user_name(player,name2,31);

	if (get_user_team(player)==1)
		T_QB = player;
	else
		CT_QB = player;
	QB_lock[get_user_team(player)] = 1;

	display_comment(16,player);
	log_amx("RF Set QB: Admin %s made %s QB",name,name2);

	return PLUGIN_HANDLED;
}

// admin can set the current down to whatever
public set_down(id,level,cid)
{
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED;
	
	new arg[32],name[32];
	read_argv(1,arg,4);
	get_user_name(id,name,31);

	if (!is_str_num(arg))
		return PLUGIN_HANDLED;

	CurDown = str_to_num(arg);

	display_comment(9,0);
	log_amx("RF Set Down: Admin %s set team #%d current down to %s",name,TeamWithBall,arg);

	return PLUGIN_HANDLED;
}

// admin can set a score to whatever he wants
public set_score(id,level,cid)
{
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED;

	new arg[32],arg2[8],name[32];
	read_argv(1,arg,31);
	read_argv(2,arg2,7);
	get_user_name(id, name,31);

	if (!is_str_num(arg2))
		return PLUGIN_HANDLED;

	if (equali(arg,"t") || equali(arg,"1"))
		tscore = str_to_num(arg2);
	else if (equali(arg,"ct") || equali(arg,"2"))
		ctscore = str_to_num(arg2);
	else {
		client_printc(id,"\g[AMXX] amx_setscore usage: \o<t|1|ct|2> <point #>");
		return PLUGIN_HANDLED;
	}

	log_amx("RF Set Score: Admin %s set the score of %s to %s",name,arg,arg2);

	return PLUGIN_HANDLED;
}

// forces one team to kickoff
public set_kick(id,level,cid)
{
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED;

	new arg[32],name[32];
	read_argv(1,arg,31);
	get_user_name(id,name,31);

	if (!GameActive || !get_cvar_num("fm_kickoffs")) {
		client_printc(id,"\g[AMXX] Unable to force kick. \o(Make sure a game is active)");
		return PLUGIN_HANDLED;
	}
	else if (equali(arg,"t") || equali(arg,"1"))
		TeamWithBall = 2;
	else if (equali(arg,"ct") || equali(arg,"2"))
		TeamWithBall = 1;
	else {
		client_printc(id,"\g[AMXX] amx_makekick usage: \o<t|1|ct|2>");
		return PLUGIN_HANDLED;
	}

	StatSnap = CurDown = PAT = 0;
	Scrimage_loc = (Ttd_loc[0]+CTtd_loc[0])/2;
	play_over(2,0);
	arrayset(Burst,1,get_maxplayers());
	Scrimage_loc = (TeamWithBall==1) ? Ttd_loc[0]-380 : CTtd_loc[0]+380;
	FirstD_loc = 10000;
	Kicking = (TeamWithBall==1) ? 2 : 1;

	log_amx("RF Make Kick: Admin %s has forced %s to kickoff.",name,arg);

	return PLUGIN_HANDLED;
}

// admin can set toggle scrim mode
public set_scrim(id,level,cid)
{
	new arg[32];
	read_argv(1,arg,31);
	if (read_argc()==2)
	{
		if (equali(arg,"on") || equali(arg,"yes") || equali(arg,"1"))
			Tourney = 1;
		else if (equali(arg,"off") || equali(arg,"no") || equali(arg,"0"))
			Tourney = 0;
		else {
			client_printc(id,"\g[AMXX] amx_scrim usage: \o<on|yes|1|off|no|0>");
			return PLUGIN_HANDLED;
		}
	}
	else
		Tourney = (Tourney) ? 0 : 1;

	if (Tourney && task_exists(5273333))
		remove_task(5273333);

	display_comment(35,id);

	new name[32];
	get_user_name(id,name,31);
	log_amx("RF Set Score: Admin %s set the Tourney/Scrim mode: %s",name,(Tourney)?"Enabled":"Disabled");

	return PLUGIN_HANDLED;
}

// admin can make a player burst
public make_burst(id,level,cid)
{
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	
	new arg[32],name[32],name2[32];
	read_argv(1,arg,31);
	new player = cmd_target(id, arg, 2);
	if (!player)
		return PLUGIN_HANDLED;
	else if (Tourney){
		client_printc(id,"\o[\gAMXX\o] \gYou are unable to MakeBurst during a scrim.");
		return PLUGIN_HANDLED;
	}
	
	get_user_name(id,name,31);
	get_user_name(player,name2,31);
	
	BrsCnt[player] = 6;
	act_burst(player);
	
	log_amx("RF Make Burst: Admin %s made %s Speed Burst",name,name2);
	
	return PLUGIN_HANDLED;
}

// make new QB
public act_qb(id)
{
	if ((id == T_QB && get_user_team(id)==1) || (id == CT_QB && get_user_team(id)==2))
		client_printc(id,"\o[\gAMXX\o] \gYou currently are the QB.");
	else if (QB_lock[get_user_team(id)])
		client_printc(id,"\o[\gAMXX\o] \gThe QB is already choosen for this drive.");
	else if (StatSnap != 2 || !GameActive)
		client_printc(id,"\o[\gAMXX\o] \gYou can only change to the QB after the play.");
	else if (get_user_team(id) == 1)
	{
		T_QB = id;
		display_comment(16,id);
		if (TeamWithBall == 1)
			QB_lock[1] = 1;
	}
	else
	{
		CT_QB = id;
		display_comment(16,id);
		if (TeamWithBall == 2)
			QB_lock[2] = 1;
	}
	return PLUGIN_CONTINUE;
}

// switch a user between teams
public act_switch(id)
{
	// if id>0 then player is specified
	if (id > 0)
	{
		if (StatSnap != 2 && GameActive && is_user_alive(id))
		{
			client_printc(id,"\o[\gAMXX\o] \gYou can only change teams after the play.")
			return;
		}
		// change users team
		cs_set_user_team(id,(get_user_team(id)==2) ? CS_TEAM_T : CS_TEAM_CT);
		display_comment(17,id);
		// clear QB if he switches
		if (id == CT_QB && id == T_QB)
			QB_lock[get_user_team(id)] = 0;
	}
	else
	{
		new players[32],count,targ,targstat;
		get_players(players,count,"a");
		for (new i=0;i<count;i++)
			if ((id == -1 && get_user_team(players[i]) == 1) || (id == -2 && get_user_team(players[i]) == 2) || get_user_team(players[i]) == 3)
				continue;
			else if ((!targ || Stats[players[i]][12]<=targstat) && !is_user_admin(players[i]) && players[i]!=CT_QB && players[i]!=T_QB)
			{
				targ = players[i];
				targstat = Stats[players[i]][12];
			}
		if (targ)
		{
			cs_set_user_team(targ,(id == -1) ? CS_TEAM_T : CS_TEAM_CT);
			display_comment(17,targ);
		}
	}
}

// if a user has a ball
public user_has_ball(id)
{
	new weapons[32],num,clip,ammo;
	if (!is_user_alive(id)) return ammo;
	get_user_weapons(id,weapons,num);
	for (new i=0; i<num; i++)
		if (weapons[i]==4)
			get_user_ammo(id,4,clip,ammo);
	return (id==FieldGoal) ? 1 : ammo;
}

// resets both teams after a turnover
public reset_drive()
{
	CurDown = 1;
	QB_lock[1] = QB_lock[2] = 0;
	new players[32],count;
	get_players(players,count,"a");
	for (new i=0;i<count;i++)
		if (Burst[players[i]])
		{
			if (task_exists(players[i]+905))
			{
				remove_task(players[i]+905);
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
				write_byte(TE_KILLBEAM);
				write_short(players[i]);
				message_end();
			}
			reset_icons(players[i])
			message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusIcon"),_,players[i]);
			write_byte(1);
			write_string("item_battery");
			write_byte(0);
			write_byte(160);
			write_byte(0);
			message_end();
			Burst[players[i]] = 0;
			BrsCnt[players[i]] = 6;
		}
}

// resets the mid left burst icons
public reset_icons(id)
{
	for (new i=0;i<7;i++)
	{
		message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusIcon"),_,id);
		write_byte(0);
		switch (i)
		{
			case 0: write_string("number_0");
			case 1: write_string("number_1");
			case 2: write_string("number_2");
			case 3: write_string("number_3");
			case 4: write_string("number_4");
			case 5: write_string("number_5");
			default: write_string("item_battery");
		}
		message_end();
	}
}

// make sure each team has a player
public check_teams()
{
	new players[32],count,teams[4];
	get_players(players,count);
	for (new i=0;i<count;i++)
	{
		if (get_user_team(players[i])>0)
			teams[get_user_team(players[i])]++;
		if (teams[1]>0 && teams[2]>0)
			return 1;
	}
	// disable tourney mode if its enabled.
	if (Tourney)
	{
		Tourney = 0;
		display_comment(35,0);
	}
	return 0;
}

// bring back the dead
public revive()
{ 
	new players[32],num;
	get_players(players,num,"b");
	for (new i=0;i<num;i++) 
		if (get_user_team(players[i])==1 || get_user_team(players[i])==2)
		{
			spawn(players[i]);
			spawn(players[i]);
		}
}

// when a play spawns
public ev_resethud(id)
{
	set_task(0.2,"reset_player",id+14234);
}

// resets play after he spawns
public reset_player(id)
{
	id -= 14234;
	if (is_user_alive(id))
	{
		// strip them incase they have a ball
		new save = user_has_ball(id);
		strip_user_weapons(id);
		if (save) give_item(id,"weapon_hegrenade");
		// heal
		set_pev(id,pev_health,1000.0);
		// take cash
		set_pdata_int(id,115,0,5);
		// make play invincible
		set_pev(id,pev_takedamage,DAMAGE_NO);
		// fix models
		ev_models(id);
		// hide uneeded hud sprites
		message_begin(MSG_ONE,get_user_msgid("HideWeapon"),_,id); 
		write_byte((1<<1) | (1<<3) | (1<<4) | (1<<5));
		message_end();
	}
}

// player leaves
public client_disconnect(id)
{
	// if the player with the ball leaves then end down
	if (user_has_ball(id) && GameActive)
		play_over(2,0);

	// error checker on ball
	ball_check(0);

	// reset afk checker
	lastmove[id] = 0.0;

	// stats tracking
	if (!is_user_bot(id) && !is_user_hltv(id))
		stats_save(id);
	for (new b=0;b<13;b++)
		Stats[id][b] = 0;
}

// make sure there is a ball somewhere if not end play
public ball_check(num)
{
	new players[32],numb,ent;
	if (!GameActive)
		return;
	while ((ent = engfunc(EngFunc_FindEntityByString,ent,"classname","grenade")) != 0)
		return;
	get_players(players,numb,"a");
	for (new i=0;i<numb;i++) 
		if (user_has_ball(players[i]))
			return;
	num++;
	if (num>2)
	{
		play_over(2,0);
		log_amx("RF Play Ended: Game:%d ScrL:%d FirDL:%d TQB:%d CTQB:%d Kick:%d StSp:%d TWBall:%d CurD:%d FDtm:%d TScr:%d CTScr:%d",GameActive,Scrimage_loc,FirstD_loc,T_QB,CT_QB,Kicking,StatSnap,TeamWithBall,CurDown,fdtime,tscore,ctscore);
	}
	else
		set_task(5.0,"ball_check",num);
}

// spawn a football
public make_ball(id)
{
	new Float:angles[3],Float:origin[3],originint[3],ent = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString, "info_target"));
	if (pev_valid(ent) && is_user_alive(id))
	{
		// make ball
		set_pev(ent,pev_classname,"grenade");
		set_pev(ent,pev_owner,id);
		set_pev(ent,pev_solid,2);
		set_pev(ent,pev_movetype,10);
		set_pev(ent,pev_gravity,1.0);
		engfunc(EngFunc_SetModel,ent,"models/w_football.mdl");

		// move ball in front of player
		pev(id,pev_v_angle,angles);
		get_user_origin(id,originint,1);
		IVecFVec(originint,origin);
		origin[0] += floatcos(angles[1],degrees) * 3.0;
		origin[1] += floatsin(angles[1],degrees) * 3.0;
		set_pev(ent,pev_angles,angles);
		set_pev(ent,pev_origin,origin);

		// game related actions
		strip_user_weapons(id);
		ev_models(id);
		grenade_throw(id,ent,10000);
		set_pev(ent,pev_iuser1,1);
		remove_task(306);
		set_task(15.0,"play_over2",306);

		return ent;
	}
	return 0;
}

// spawns the score clock digits
public make_scoreclock(const targetname[32],Float:origin[3],Float:angles[3],Float:scale)
{
	new ent, Float:origin2[3], count = (containi(targetname,"counter_score")) ? 0 : 2, origdiff = floatround(scale*8.0);
	for (new a=0;a<2;a++)
	{
		ScoreClock[a+count] = ent = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString, "info_target"));
		if (pev_valid(ent))
		{
			set_pev(ent,pev_classname,"sclock");
			engfunc(EngFunc_SetModel,ent,"sprites/clock_digits.spr");
			set_pev(ent,pev_scale,scale);
			origin2 = origin;
			if (angles[1] == 180.0 || angles[1] == -180.0) origin2[1] += (a) ? origdiff : -origdiff;
			else if (angles[1] == 0.0) origin2[1] -= (a) ? origdiff : -origdiff;
			else if (angles[1] == 90.0) origin2[0] += (a) ? origdiff : -origdiff;
			else if (angles[1] == -90.0) origin2[0] -= (a) ? origdiff : -origdiff;
			set_pev(ent,pev_origin,origin2);
			set_pev(ent,pev_angles,angles);
			set_pev(ent,pev_frame,0.0);
			set_pev(ent,pev_solid,0);
			set_pev(ent,pev_movetype,5);
		}
	}
}

// runs over n over
public recure_sec()
{
	new players[32],num,origin[3],name[25],mssge[192],teamnum,target,null;
	//scoreboard
	if (GameActive)
	{
		if (!Kicking) 
		{
			null = floatround((TeamWithBall==1) ? (Scrimage_loc-CTtd_loc[0])/30.0 : (Ttd_loc[0]-Scrimage_loc)/30.0);
			switch (CurDown)
			{
				case 1: formatex(mssge,29,"%dst Down %d YardstoTD",CurDown,null);
				case 2: formatex(mssge,29,"%dnd Down %d YardstoTD",CurDown,null);
				case 3: formatex(mssge,29,"%drd Down %d YardstoTD",CurDown,null);
				default: formatex(mssge,29,"%dth Down %d YardstoTD",CurDown,null);
			}
		}
		set_hudmessage(0, 240, 0, -0.75, -0.78, 0, 0.0, 4.0, 0.0, 0.0, -1);
		ShowSyncHudMsg(0, g_msgsboard, "%s   ^n   Counter-Terror: %d^n   Terrorists:         %d^n%s^n%s",(Tourney)?"FB Tournament Mode":"American Football Mod",ctscore,tscore,mssge,(NoRushing) ? "   Rushing is Disabled" : "");
		if (Ttd_loc[3] && StatSnap == 1)
		{
			new Float:forigin[3];
			while ((num = engfunc(EngFunc_FindEntityByString,num,"classname","grenade")) != 0)
			{
				pev(num,pev_origin,forigin);
				FVecIVec(forigin,origin);
				if ((origin[1]>Ttd_loc[1]+Ttd_loc[3] || origin[1]<Ttd_loc[1]-Ttd_loc[3]) && get_user_team(pev(num,pev_euser1))!=3)
				{
					display_comment(34,0);
					if (Fumblestat[1])
						play_over(1,pev(num,pev_euser1));
					else
						play_over(2,0);
				}
			}
		}
	}

	get_players(players,num,"a");
	for (new i=0;i<num;i++)
	{
		// get users origin and team
		get_user_origin(players[i],origin);
		teamnum = get_user_team(players[i]);
		if (teamnum != 1 && teamnum != 2)
			continue;
		// check to see if player crossed the line of scrimmage
		if (NoRushing && GameActive && FirstD_loc!=10000 && StatSnap==1 && !is_user_bot(players[i]) && (user_has_ball(T_QB) || user_has_ball(CT_QB)))
			if (((origin[0]<Scrimage_loc && teamnum==1) || (origin[0]>Scrimage_loc && teamnum==2)) && (teamnum!=TeamWithBall || (user_has_ball(players[i]) && (players[i]==CT_QB || players[i]==T_QB))))
			{
				// freeze player
				origin[0] = (teamnum==1) ? Ttd_loc[0]+25 : CTtd_loc[0]-25;
				origin[1] = CTtd_loc[1]+random_num(-600,600);
				origin[2] = CTtd_loc[2]-25;
				set_user_origin(players[i],origin);
				// say player is offside
				display_comment(18,players[i]);
				// tell them to use help messages cause they are noobs
				set_hudmessage(255, 255, 255, -1.0, -0.84, 0, 1.0, 12.0, 2.0, 2.0, -1);
				ShowSyncHudMsg(players[i], g_msghelp, "You have been caught rushing when it is prohibited.");
				// end play if carrier dies
				if (user_has_ball(players[i]))
				{
					play_over(2,0);
					// make player not glow
					fm_set_rendering(players[i]);
				}
				continue;
			}
		// check to see if player is outta bounds
		if (Ttd_loc[3] && GameActive && StatSnap==1 && !is_user_bot(players[i]))
			if ((origin[1]>Ttd_loc[1]+Ttd_loc[3]) || (origin[1]<Ttd_loc[1]-Ttd_loc[3]))
			{
				// say player is outta bounds
				display_comment(32,players[i]);
				// tell them they are outta bounds
				set_hudmessage(255, 255, 255, -1.0, -0.84, 0, 1.0, 12.0, 2.0, 2.0, -1);
				ShowSyncHudMsg(players[i], g_msghelp, "You have ran out of bounds which is prohibited.");
				if (user_has_ball(players[i]))
				{
					// end play
					play_over(1,players[i]);
					// make player not glow
					fm_set_rendering(players[i]);
				}
				else
				{
					// freeze player
					origin[0] = (teamnum==1) ? Ttd_loc[0]+25 : CTtd_loc[0]-25;
					origin[1] = CTtd_loc[1]+random_num(-600,600);
					origin[2] = CTtd_loc[2]-25;
					set_user_origin(players[i],origin);
				}
				continue;
			}
		// touchdown check
		if (GameActive && StatSnap==1 && user_has_ball(players[i]))
			if ((origin[0]<CTtd_loc[0] && teamnum==1) || (origin[0]>Ttd_loc[0] && teamnum==2))
				play_over(1,players[i]);
		// check if player is aiming at another player and if so show their stats
		get_user_aiming(players[i],target,null)
		if (target && is_user_alive(target) && target!=players[i])
		{
			get_user_name(target,name,24);
			formatex(mssge,191,"-=Player Stats=- %s (QB:%d) (Player:%d) ^nRec: %d/%d (%d%%) | Tckl: %d | TD: %d | Int: %d ^nQB | Play: %d | Pass: %d/%d (%d%%)| TD: %d | Int: %d",name,Stats[target][11],Stats[target][12],Stats[target][1],Stats[target][2],percentage(Stats[target][1],Stats[target][2]),Stats[target][7],Stats[target][9],Stats[target][8],Stats[target][0],Stats[target][4],Stats[target][3],percentage(Stats[target][4],Stats[target][3]),Stats[target][5],Stats[target][6]);
			set_hudmessage(255, 128, 0, -1.0, -0.84, 1, 1.0, 4.0, 0.5, 0.5, -1);
			ShowSyncHudMsg(players[i],g_msghelp,"%s",mssge);
		}
	}
}

// randomize teams
public teams_shake()
{ // 0=Leavealone 1=T 2=CT 3=Pickrand
	new Playerteam[34], tplayers, tcts, tts, overflow, randnum, g_maxplayers = get_maxplayers()+2;
	for (new i=0;i<g_maxplayers;i++) // check teams and determine which can be switched
	{
		if (is_user_connected(i))
			if ((get_user_flags(i) & ADMIN_IMMUNITY) || is_user_bot(i) || is_user_hltv(i) || (cs_get_user_team(i) == CS_TEAM_SPECTATOR))
			{
				Playerteam[i] = 0;
				if (cs_get_user_team(i) == CS_TEAM_T)
					tts++;
					else if (cs_get_user_team(i) == CS_TEAM_CT)
						tcts++;
			}
			else
			{
				Playerteam[i] = 3;
				tplayers++;
			}
	}
	while (tplayers>0 && overflow++<1000) // determine which team we are gonna put the switchers on
	{
		randnum = random_num(1,g_maxplayers)
		if (is_user_connected(randnum) && Playerteam[randnum]==3)
			if (tts < tcts)
			{
				Playerteam[randnum] = 1;
				tts++;
				tplayers--;
			}
			else
			{
				Playerteam[randnum] = 2;
				tcts++;
				tplayers--;
			}
			 
	}
	for (new i=0;i<g_maxplayers;i++) // perform all switches and respawn all players
		if (is_user_connected(i) && Playerteam[i]>0)
			cs_set_user_team(i,(Playerteam[i] == 1) ? CS_TEAM_T : CS_TEAM_CT);
	// display message
	display_comment(21,0);
	return PLUGIN_HANDLED
}

// find the nearest player to the football within 333 origin points.
stock nearest_teammate(ent)
{
	new players[32],num,Float:originb[3],Float:originp[3],id = pev(ent,pev_euser1),cloid=0,Float:clodis=333.0,Float:temp;
	pev(ent,pev_origin,originb);
	get_players(players,num,"a");
	for (new i=0;i<num;i++)
	{
		if (players[i] == id || get_user_team(players[i]) != get_user_team(id))
			continue;
		pev(players[i],pev_origin,originp);
		temp = get_distance_f(originb,originp);
		if (temp<=clodis)
		{
			cloid = players[i];
			clodis = temp;
		}
	}
	return cloid;
}

// fakemeta set_rendering via fm itilities
stock fm_set_rendering(entity,fx=kRenderFxNone,r=0,g=0,b=0,render=kRenderNormal,amount=16)
{
	new Float:RenderColor[3];
	RenderColor[0] = float(r);
	RenderColor[1] = float(g);
	RenderColor[2] = float(b);
	set_pev(entity,pev_renderfx,fx);
	set_pev(entity,pev_rendercolor,RenderColor);
	set_pev(entity,pev_rendermode,render);
	set_pev(entity,pev_renderamt,float(amount));
	return 1;
}

// send a flash of light where the player is standing
public act_lflash(id)
{
	if (!is_user_alive(id))
		return;
	static origin[3];
	get_user_origin(id,origin);
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(27);
	write_coord(origin[0]);
	write_coord(origin[1]);
	write_coord(origin[2]);
	write_byte(50);
	write_byte(255);
	write_byte(255);
	write_byte(255);
	write_byte(8);
	write_byte(60);
	message_end();
}

// makes the ball has a shockwave pulse around it
public act_shockwave(greindex)
{
	greindex -= 7000;
	if (!pev_valid(greindex))
		return;
	if (pev(greindex,pev_flags) & FL_ONGROUND)
	{
		static Float:origin1[3],origin[3];
		pev(greindex,pev_origin,origin1)
		FVecIVec(origin1,origin);
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
		write_byte(21);
		write_coord(origin[0]);
		write_coord(origin[1]);
		write_coord(origin[2]-10);
		write_coord(origin[0]);
		write_coord(origin[1]);
		write_coord(origin[2]+10);
		write_short(spr[1]);
		write_byte(0);	// startframe
		write_byte(0);	// framerate in 0.1's
		write_byte(2);
		write_byte(64);	// width
		write_byte(255);// noise
		write_byte(0);// red
		write_byte(255);// green
		write_byte(0);
		write_byte(140);//bright
		write_byte(0);	//scrollspeed
		message_end();
	}
	greindex += 7000;
	remove_task(greindex);
	set_task(2.2,"act_shockwave",greindex);
}

// same as client_print but allows you to add colours
stock client_printc(const id, const input[], any:...)
{
	new msg[191], players[32], count = 1;
	vformat(msg,190,input,3);
	replace_all(msg,190,"\g","^4");// green clr
	replace_all(msg,190,"\o","^1");// orange clr
	replace_all(msg,190,"\t","^3");// team clr
	if (id) players[0] = id; else get_players(players,count,"ch");
	for (new i=0;i<count;i++)
		if (is_user_connected(players[i]))
		{
			message_begin(MSG_ONE_UNRELIABLE,76,_,players[i]);
			write_byte(players[i]);
			write_string(msg);
			message_end();
		}
}

// calculated qb rating
stock qb_rating(id)
{
	static Float:base[5],Float:data[5];
	data[1] = float(Stats[id][3]); data[2] = float(Stats[id][4]); data[3] = float(Stats[id][5]); data[4] = float(Stats[id][6]);
	base[1] = (((data[2]/data[1])*100.0)-30.0)*0.05;
	base[2] = 1.4;
	base[3] = ((data[3]/data[1])*100.0)*0.2;
	base[4] = 2.375-(((data[4]/data[1])*100.0)*0.25);
	for (new a=1;a<5;a++)
		if (base[a]>2.375) base[a] = 2.375;
		else if (base[a]<0.0) base[a] = 0.0;
	return floatround(((base[1]+base[2]+base[3]+base[4])/6.0)*100.0);
}

// calculates player rating
stock player_rating(id)
{
	static Float:data[11];
	data[0] = float(Stats[id][0]); data[1] = float(Stats[id][1]); data[2] = float(Stats[id][2]); data[3] = float(Stats[id][3]); data[4] = float(Stats[id][4]);
	data[5] = float(Stats[id][5]); data[6] = float(Stats[id][6]); data[7] = float(Stats[id][7]); data[8] = float(Stats[id][8]); data[9] = float(Stats[id][9]);
	return floatround(data[1] - ((data[2]+1)/2.2) + (data[7]*0.34) + data[8] + data[4] - ((data[3]+1)/2.2) + data[5] - data[6] + data[9] - (data[0]*0.03)+2);
}

// calculates the date as 1 int in days (used for calculating days)
stock date_int()
{
	new temp[32],days=0;
	format_time(temp,31,"%d");
	days += str_to_num(temp);
	format_time(temp,31,"%m");
	days += (str_to_num(temp)-1)*30;
	format_time(temp,31,"%Y");
	return days += str_to_num(temp)*365;
}

// formats the percentage of 2 ints
stock percentage(const base1,const base2)
{
	new Float:base1b = float(base1),Float:base2b = float(base2);
	return floatround(((base1b+0.01)/(base2b+0.01))*100);
}

///////////////////////STATS///////////////////////
// 0 = plays
// 1 = catches
// 2 = thrown to
// 3 = throws
// 4 = complete
// 5 = tdpass
// 6 = ints
// 7 = tackles
// 8 = interceptions
// 9 = tds
// 11 = qb rating
// 12 = player rating
///////////////////////////////////////////////////

// loads players stats from the vault when he connects
public client_putinserver(id)
{	
	if (is_user_bot(id) || is_user_hltv(id))
		return;

	new vault = nvault_open("football");

	// make sure our stats vault opens err free
	if (vault != INVALID_HANDLE)
	{
		new steamid[32],pstats[14][11],key[32],val[200],TimeStamp;

		// set steamid as our key unique value
		get_user_authid(id,steamid,31);
		formatex(key,31,"%s",steamid);
		
		// check if player exists in stats vault
		if (nvault_lookup(vault,key,val,199,TimeStamp))
		{
			// set stats data
			parse(val, steamid,1, steamid,1, pstats[0],10, pstats[1],10, pstats[2],10, pstats[3],10, pstats[4],10, pstats[5],10, pstats[6],10, pstats[7],10, pstats[8],10, pstats[9],10, pstats[10],10, pstats[11],10, pstats[12],10);
			for (new b=0;b<13;b++)
				Stats[id][b] = str_to_num(pstats[b]);
		}
		else 
		{
			// clear stats for new player
			for (new b=0;b<13;b++)
				Stats[id][b] = 0;
			client_printc(id,"\o[\gAMXX\o] [\gFootball Mod\o] \gIf you need any help type \t/help\g in chat.");
		}

		nvault_close(vault);
	}
	else
		log_amx("[Nvault] Football Mod: Err loading stats %d... INVALID_HANDLE",id);
}

// saves the players current stats into the vault
public stats_save(id)
{
	if (!is_user_connected(id) || is_user_bot(id) || is_user_hltv(id) || (!Stats[id][0] && !Stats[id][1] && !Stats[id][2] && !Stats[id][4] && !Stats[id][7] && !Stats[id][8] && !Stats[id][12]))
		return;

	new vault = nvault_open("football");
	Stats[id][11] = qb_rating(id);

	if (vault != INVALID_HANDLE)
	{
		new username[20],key[32],update[200],TimeStamp;

		get_user_authid(id,key,31);
		get_user_name(id,username,19);
		remove_quotes(username);
		
		// check if player is unique
		if (!nvault_lookup(vault,key,update,1,TimeStamp)) 
		{
			// add new unique
			new unique[32],i,cont,numofunique = nvault_get(vault,"numofunique");
			while (i++<=numofunique+5 && !cont)
			{
				formatex(unique,31,"%d",i);
				if (!nvault_lookup(vault,unique,update,1,TimeStamp)) 
				{
					nvault_pset(vault,unique,key);
					if (i>numofunique)
						nvault_pset(vault,"numofunique",unique);
					cont = true;
				}
			}
		}
		
		// save player stats into the vault
		format(update,199,"^"%s^" %i %i %i %i %i %i %i %i %i %i %i %i %i %i",username,date_int(),Stats[id][0],Stats[id][1],Stats[id][2],Stats[id][3],Stats[id][4],Stats[id][5],Stats[id][6],Stats[id][7],Stats[id][8],Stats[id][9],Stats[id][10],Stats[id][11],Stats[id][12]);
		nvault_set(vault,key,update);
	
		nvault_close(vault);
	}
	else
		log_amx("[Nvault] Football Mod: Err saving stats %d... INVALID_HANDLE",id);
}

// removes players stats from vault.
public stats_reset(id)
{
	if (!is_user_connected(id) || is_user_bot(id) || is_user_hltv(id))
		return;
	else if (!get_cvar_num("fm_allowstatreset"))
	{
		client_printc(id,"\o[\gAMXX\o] \gReset stats is currently disabled.");
		return;
	}

	new vault = nvault_open("football");

	if (vault != INVALID_HANDLE)
	{
		new key[32];
		get_user_authid(id,key,31);
		nvault_remove(vault,key);
		display_top(id,12);
		client_printc(id,"\o[\gAMXX\o] \gYour stats have been \oerased\g.");
	}
	else
		log_amx("[Nvault] Football Mod: Err resetting stats %d... INVALID_HANDLE",id);

	for (new b=0;b<13;b++)
		Stats[id][b] = 0;
}

// fetches and displays a motd of stats
public display_top(id,sort)
{
	new vault = nvault_open("football");

	if (vault != INVALID_HANDLE)
	{
		new top15id[16][32],topvalu[16],temp,tempid[32],j,k;
		new steamid[32],username[32],pstats[14][11],key[32],val[200],TimeStamp,daydif,day = date_int();
		new mssge[2047],iLen,type = (sort==3 || sort==4 || sort==5 || sort==6 || sort==11) ? 1 : 0;
		// copy and sort leaders
		for(new i=1;i<=nvault_get(vault,"numofunique");i++)
		{
			formatex(key,31,"%d",i);
			if (nvault_lookup(vault,key,val,100,TimeStamp)) 
			{
				parse(val, key,31, steamid,1);
				if (nvault_lookup(vault,key,val,199,TimeStamp)) 
				{
					parse(val, steamid,1, username,11, pstats[0],10, pstats[1],10, pstats[2],10, pstats[3],10, pstats[4],10, pstats[5],10, pstats[6],10, pstats[7],10, pstats[8],10, pstats[9],10, pstats[10],10, pstats[11],10, pstats[12],10);

					// clear old data out of vault for performance
					daydif = day-str_to_num(username);
					if (daydif>40 || (daydif>4 && str_to_num(pstats[0])<100) || (daydif>7 && str_to_num(pstats[0])<200))
					{
						nvault_remove(vault,key);
						formatex(key,31,"%d",i);
						nvault_remove(vault,key);
						continue;
					}
				}
				else
				{
					formatex(key,31,"%d",i);
					nvault_remove(vault,key);
					continue;			
				}
			}
			else
				continue;
			// filter qbs with under 25 throws
			if (type && str_to_num(pstats[3])<25)
				continue;
			// check to see if current player is > then current leaders
			temp = str_to_num(pstats[sort]); tempid = key;
			j = 14; k = 0;
			while (j-->0 && !k)
			{
				if (temp>topvalu[j])
				{
					topvalu[j+1] = topvalu[j];	top15id[j+1] = top15id[j];
					topvalu[j] = temp;		top15id[j] = tempid;
				}
				else
					k = 1;
			}
		}
		iLen = formatex(mssge, 2047, "<body bgcolor=#2A2A2A><center><table bgcolor=#383838 style='text-align:center;color:white;font-family:tahoma;font-size:11px;border:#565656 1px solid'>");
		if (type)
			iLen += formatex(mssge[iLen], 2047 - iLen, "<tr><td colspan=9>American Football Mod Top 15 QB's<tr><td bgcolor=#008080>Player<td bgcolor=#008080>Plays<td bgcolor=#F08030>Comp<td bgcolor=#F08030>Atmp<td bgcolor=#F08030>TD Pass<td bgcolor=#F08030>Ints.<td bgcolor=#F08030>QB Rating");
		else
			iLen += formatex(mssge[iLen], 2047 - iLen, "<tr><td colspan=9>American Football Mod Top 15 Players<tr><td bgcolor=#008080>Player<td bgcolor=#008080>Plays<td bgcolor=#639CCE>Catches/Passes<td bgcolor=#639CCE>TDs<td bgcolor=#A890F0>Tackles<td bgcolor=#A890F0>Ints.<td bgcolor=#008080>Rating");
		for(new i=0;i<15;i++)
		{
			formatex(key,31,"%s",top15id[i]);
			if (nvault_lookup(vault,key,val,199,TimeStamp)) 
			{
				parse(val, username,31, steamid,1, pstats[0],10, pstats[1],10, pstats[2],10, pstats[3],10, pstats[4],10, pstats[5],10, pstats[6],10, pstats[7],10, pstats[8],10, pstats[9],10, pstats[10],10, pstats[11],10, pstats[12],10);
				replace_all(username,31,"<",""); replace_all(username,31,">","");
				if (type)
					iLen += formatex(mssge[iLen], 2047 - iLen, "<tr><td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s",username,pstats[0],pstats[4],pstats[3],pstats[5],pstats[6],pstats[11]);
				else
					iLen += formatex(mssge[iLen], 2047 - iLen, "<tr><td>%s<td>%s<td>%s/%s<td>%s<td>%s<td>%s<td>%s",username,pstats[0],pstats[1],pstats[2],pstats[9],pstats[7],pstats[8],pstats[12]);
			}
		}
		iLen += formatex(mssge[iLen], 2047 - iLen, "</table>");
		show_motd(id,mssge,"Football Stats");
		nvault_close(vault);
	}
	else
		log_amx("[Nvault] Football Mod: Err loading top 15 %d... INVALID_HANDLE",id);
}

// displays players stats in print_chat form
public display_client(id,target)
{
	Stats[id][11] = qb_rating(id);
	Stats[id][12] = player_rating(id);
	
	client_printc(id,"\g[AMXX] \o[\gFootball\o] \t%d \gplays \t%d\g/\t%d \gcatches \t%d \gtds \t%d \gtackle \t%d \gints \t%d \grating",Stats[id][0],Stats[id][1],Stats[id][2],Stats[id][9],Stats[id][7],Stats[id][8],Stats[id][12]);
	client_printc(id,"\g[AMXX] \o[\gQuarterback\o] \t%d \gcomplete \t%d \gattempt \t%d \gtd passes \t%d \gints \t%d \gQB rating",Stats[id][4],Stats[id][3],Stats[id][5],Stats[id][6],Stats[id][11]);
}

// hooks players say commands
public handle_say(id)
{
	lastmove[id] = get_gametime();
	new message[192],command[21];
	read_args(message,192);
	remove_quotes(message);
	strcat(command,message,20);

	if (containi(command, "how do")!=-1)
		display_info(id);
	else if (message[0]!='/' && message[0]!='.')
		return PLUGIN_CONTINUE;
	else if (containi(command, "topqb")!=-1)
		display_top(id,11);
	else if (containi(command, "top")!=-1 || containi(command, "top15")!=-1 || containi(command, "topplayer")!=-1)
	{
		stats_save(id);
		Stats[id][11] = qb_rating(id);
		if (containi(command, "0")!=-1 ||  containi(command, "play")!=-1)
			display_top(id,0);
		else if ((containi(command, "catch")!=-1 || containi(command, "wr")!=-1) && containi(command, "11")==-1 && containi(command, "12")==-1)
			display_top(id,1);
		else if (containi(command, "2")!=-1 || containi(command, "thrownto")!=-1 || containi(command, "thrown")!=-1)
			display_top(id,2);
		else if (containi(command, "3")!=-1 || containi(command, "qbthrows")!=-1 || containi(command, "rec")!=-1 || containi(command, "qbpasses")!=-1)
			display_top(id,3);
		else if (containi(command, "4")!=-1 || containi(command, "qbcomp")!=-1 || containi(command, "qbpass")!=-1)
			display_top(id,4);
		else if (containi(command, "5")!=-1 || containi(command, "qbtd")!=-1)
			display_top(id,5);
		else if (containi(command, "6")!=-1 || containi(command, "qbint")!=-1)
			display_top(id,6);
		else if (containi(command, "7")!=-1 || containi(command, "tac")!=-1 || containi(command, "sack")!=-1)
			display_top(id,7);
		else if (containi(command, "8")!=-1 || containi(command, "int")!=-1 || containi(command, "pick")!=-1 || containi(command, "db")!=-1)
			display_top(id,8);
		else if (containi(command, "9")!=-1 || containi(command, "td")!=-1 || containi(command, "touchdo")!=-1 || containi(command, "pass")!=-1)
			display_top(id,9);
		else if (containi(command, "11")!=-1 || containi(command, "qbra")!=-1 || containi(command, "passer")!=-1)
			display_top(id,11);
		else
			display_top(id,12);
	}
	else if (containi(command, "resetra")!=-1 || containi(command, "resetst")!=-1 || containi(command, "removest")!=-1 || containi(command, "clearst")!=-1)
		stats_reset(id);
	else if (containi(command, "rank")!=-1 || containi(command, "stat")!=-1)
		display_client(id,id);

	return PLUGIN_CONTINUE;
}

// saves all players stats if the server shuts down
public plugin_end()
{
	for (new b=0;b<get_maxplayers();b++)
		stats_save(b);

	new vault = nvault_open("football");
	if (vault != INVALID_HANDLE)
	{
		nvault_prune(vault,0,get_systime()-3628800)
		nvault_close(vault);
	}
}